<?php



// -- the page builder elements
$dzspgb_templates = array();







class DZSDirectoryFrontEnd {


  public $db_mainoptions = '';
  public $dbname_mainoptions = 'dzsdtf_options';


  public $name_prefix = 'dzsdtf';
  public $name_port_item = 'dir_items';
  public $name_port_item_cat = 'dir_items_cat';
  public $name_port_item_tag = 'dir_items_tag';

  public $name_frontend_forms = 'dir_frontend_forms';

  public $post_types = array();

  public $arr_for_select_post_type_opts = array();


  public $capability_admin = 'manage_options';

  private $adminpagename_mainoptions = 'dzsdtf-mo';
  private $adminpagename_batchupload = 'page-dzstln-batchupload';

  private $capability_for_menu = 'manage_options';




  public $base_url = '';
  public $base_path = '';
  public $title_label = '';

  public $shortcode_index = 0; // -- the iteration of the shortcode
  public $zfolio_index = 0; // -- the iteration of the shortcode


  public $page_is_reorder = false;



  public $allowed_tags = array(
    'p'=>array(
      'class'=>array(),
      'style'=>array(),
    ),
    'img'=>array(
      'src'=>array(),
      'class'=>array(),
      'alt'=>array(),
      'style'=>array(),
    ),
    'span'=>array(
      'style'=>array(),
      'class'=>array(),
    ),
    'strong'=>array(
      'style'=>array(),
      'class'=>array(),
    ),
    'em'=>array(
      'style'=>array(),
      'class'=>array(),
    ),
    'ul'=>array(
      'style'=>array(),
      'class'=>array(),
    ),
    'ol'=>array(
      'style'=>array(),
      'class'=>array(),
    ),
    'li'=>array(
      'style'=>array(),
      'class'=>array(),
    ),
    'hr'=>array(
      'style'=>array(),
      'class'=>array(),

    ),
    'blockquote'=>array(
      'style'=>array(),
      'class'=>array(),

    ),
    'a'=>array(
      'href' => array(),
      'target' => array(),
      'style'=>array(),
      'class'=>array(),
    ),
  );

  private $term_metas = array();
  function __construct() {





    $this->base_url = plugins_url('',__FILE__).'/';
    $this->base_path = dirname(__FILE__).'/';



    $defaultOpts = array(
      'post_types_for_meta'=>array(
        'post',
      ),
      'gmaps_api_key' => '',
      'gmaps_style' => '',
      'user_class' => 'all',
      'extra_css' => '',
    );
    $this->db_mainoptions = get_option($this->dbname_mainoptions);

    // -- default opts / inject into db
    if ($this->db_mainoptions == '') {
      $this->db_mainoptions = $defaultOpts;
      update_option($this->dbname_mainoptions, $this->db_mainoptions);
    }

    $this->db_mainoptions = array_merge($defaultOpts, $this->db_mainoptions);


    $this->arr_for_select_post_type_opts = array(
      array(
        'label'=>'post'
      ,'value'=>'post'
      ),array(
        'label'=>'page'
      ,'value'=>'page'
      ),
    );



    $this->check_posts();








    if(is_admin()){

    }

    $primary_dir = $this->base_path.'pagebuilder/elements';


    if ($handle3 = opendir($primary_dir)) {



      while (false !== ($entry = readdir($handle3))) {


        if ($entry == '.' || $entry == '..' || $entry == '.DS_Store') {
          continue;
        }




        $auxfile = $primary_dir . '/' . $entry;


        if (file_exists($auxfile)) {
          include_once($auxfile);
        }

      }
    }




    $this->term_metas = array(
      array(
        'name'=>'icon',
        'title'=>__('Icon'),
        'description'=>__('main icon of the category'),
        'type'=>'iconselector',
      ),
      array(
        'name'=>'color',
        'title'=>__('Tag Color'),
        'description'=>__('for tag color '),
        'type'=>'color',
      ),
      array(
        'name'=>'image',
        'title'=>__('Image'),
        'description'=>__('image'),
        'type'=>'media-upload',
      ),
    );





    add_action('wp_ajax_dzsdtf_ajax_mo',array($this,'post_save_mo'));
    add_action('wp_ajax_dzsdtf_get_post_thumb_url',array($this,'post_get_post_thumb_url'));
    add_action('wp_ajax_dzs_update_term_order',array($this,'post_dzs_update_term_order'));
    add_action('wp_ajax_dzsdtf_ajax_get_attachment_url', array($this, 'post_get_attachment_url'));
    add_action('wp_ajax_dzsdtf_tabs_sort', array($this, 'post_tabs_sort'));


    add_action('init',array($this,'handle_init'),30);
    add_action('init',array($this,'handle_init_end'), 99999);
    add_action('wp_head',array($this,'handle_wp_head'),40);
    add_action('admin_init',array($this,'handle_admin_init'),40);
    add_action('admin_head',array($this,'handle_admin_head'),40);
    add_action('admin_menu',array($this,'handle_admin_menu'));
    add_action('admin_footer',array($this,'handle_admin_footer'));
    add_action('add_meta_boxes',array($this,'handle_add_meta_boxes'));



    add_action( 'edit_form_after_title', array($this, 'handle_edit_form_after_title') );
//        add_action( 'plugins_loaded', array($this, 'handle_plugins_loaded') );

    add_action('save_post',array($this,'handle_admin_meta_save'));



    add_action('customize_register', array($this, 'handle_customize_register'));


//	    echo 'ceva';


    add_shortcode('directory_search', array($this, 'shortcode_directory_search'));
    add_shortcode('directory_form', array($this, 'shortcode_directory_form'));
    add_shortcode('directory_submit', array($this, 'shortcode_directory_submit'));
    add_shortcode('directory_filter_tags', array($this, 'shortcode_directory_filter_tags'));
    add_shortcode('directory_tag_display', array($this, 'shortcode_directory_tag_display'));
    add_shortcode('directory_pricing_table', array($this, 'shortcode_directory_pricing_table'));


    add_shortcode('dzspgb_row', array($this, 'shortcode_dzsdtf_row'));
    add_shortcode('dzspgb_row_part', array($this, 'shortcode_dzsdtf_row_part'));
    add_shortcode('dzspgb_element', array($this, 'shortcode_dzsdtf_element'));




    add_action( 'woocommerce_order_status_completed', array($this, 'woocommerce_order_status_completed'), 10, 1 );



    // -- comments
    add_action( 'comment_form_logged_in_after', array( $this, 'handle_comment_form_logged_in_after' ) ); // Logged in


    add_action( 'comment_post', array( $this, 'handle_save_rating' ) );
    add_action( 'edit_comment', array( $this, 'handle_save_rating' ) );



    add_filter( 'the_content', array( $this, 'filter_the_content_add_average_rating' ) );
    add_filter( 'comment_text', array( $this, 'filter_comment_text_display_rating' ) );





    add_action( 'dir_items_cat_edit_form_fields', array($this,'term_meta_fields'), 10, 10 );
    add_action( 'product_cat_edit_form_fields', array($this,'term_meta_fields'), 10, 10 );
    add_action( 'dir_items_tag_edit_form_fields', array($this,'term_meta_fields'), 10, 10 );



    add_action( 'edited_dir_items_cat', array($this,'save_taxonomy_custom_meta'), 10, 2 );
    add_action( 'edited_product_cat', array($this,'save_taxonomy_custom_meta'), 10, 2 );
    add_action( 'edited_dir_items_tag', array($this,'save_taxonomy_custom_meta'), 10, 2 );


  }

  function term_meta_fields($term){
    // this will add the custom meta field to the add new term page

    $struct_uploader = '<div class="dzs-wordpress-uploader insert-id">
<a href="#" class="button-secondary">' . __('Upload', 'dzsvp') . '</a>
</div>';

    foreach ($this->term_metas as $tem) {
      ?>

      <?php


      $t_id = $term->term_id;

      // retrieve the existing value(s) for this meta field. This returns an array
      $term_meta = get_option("taxonomy_$t_id"); ?>
        <tr class="form-field">
            <th scope="row" valign="top"><label
                        for="term_meta[<?php echo $tem['name']; ?>]"><?php echo $tem['title']; ?></label></th>
            <td class="<?php
            if($tem['type']=='media-upload'){
              echo 'setting-upload';
            }
            ?>">





              <?php

              if($tem['type']=='media-upload'){
                echo '<span class="uploader-preview"></span>';
              }
              ?>



              <?php
              $lab = 'term_meta['.$tem['name'].']';

              $val = '';

              if(isset($term_meta[$tem['name']])){

                $val = esc_attr($term_meta[$tem['name']]) ? esc_attr($term_meta[$tem['name']]) : '';
              }

              $class = 'setting-field medium';


              if($tem['type']=='media-upload') {
                $class.=' uploader-target';

                wp_enqueue_media();
              }

              if($tem['type']=='color') {
                $class .= ' color-with-spectrum';
              }
              if($tem['type']=='media-upload' || $tem['type']=='text' || $tem['type']=='input') {
              }

              if($tem['type']=='iconselector') {
              wp_enqueue_style('spectrum',$this->base_url.'libs/spectrum/spectrum.css');
              wp_enqueue_script('spectrum',$this->base_url.'libs/spectrum/spectrum.js');
              wp_enqueue_script('faiconselector',$this->base_url.'libs/dzsiconselector/dzsiconselector.js');
              wp_enqueue_style('faiconselector',$this->base_url.'libs/dzsiconselector/dzsiconselector.css');

              $class.= ' style-iconselector iconselector-waiter';
              ?><div class="iconselector" data-input-acts-as-search="on">
                    <p>

                        <span class="iconselector-preview"></span>
                      <?php
                      }

                      echo DZSHelpers::generate_input_text($lab, array(
                        'class' => $class,
                        'seekval' => $val,
                        'id' => $lab,
                      ));
                      if($tem['type']=='iconselector') {
                      ?>
                        <span class="iconselector-btn"><i class="fa fa-caret-down"></i>
                    </p>

                    </span><div class="iconselector-clip"><?php
                  $icons_html = '';
                  include_once "class_parts/faicons_html.php";
                  echo $icons_html;
                  ?></div>
                </div><?php
            }


            if($tem['type']=='color') {
//                DZSHelpers::generate_input_text($lab, array('val' => '', 'class' => 'wp-color-picker-init ', 'seekval' => $val));
            }

            if($tem['type']=='media-upload') {
              echo $struct_uploader;
            }
            ?>
              <?php

              ?>
                <p class="description"><?php _e('Enter a value for this field', 'pippin'); ?></p>
            </td>
        </tr>
      <?php
    }
  }

  function save_taxonomy_custom_meta( $term_id ) {
    if ( isset( $_POST['term_meta'] ) ) {
      $t_id = $term_id;
      $term_meta = get_option( "taxonomy_$t_id" );
      $cat_keys = array_keys( $_POST['term_meta'] );
      foreach ( $cat_keys as $key ) {
        if ( isset ( $_POST['term_meta'][$key] ) ) {
          $term_meta[$key] = $_POST['term_meta'][$key];
        }
      }
      // Save the option array.
      update_option( "taxonomy_$t_id", $term_meta );
    }
  }





  function filter_the_content_add_average_rating($content){



    if(is_single()){
      global $post;

      $avg = $this->get_ratings_avg_for_post($post->ID);


//	        echo '$avg - '.$avg;
      if($avg) {

        $content.='<h6 class="avg-rating">'.esc_html__("Rating",'dzsdtf').'</h6>';
        // Build rating HTML
        $content .= '<div class="dzs-star-rating-average">';


        $content .= '<div class="clear"> </div>
        <div class="dzs-ratings-con dzs-ratings-con--content">
        <div class="dzs-ratings-con-bg"><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span></div>
        <div class="dzs-ratings-con-prog" style="width: ' . ( ( $avg * 20 ) ) . '%;"><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span></div>
        </div>';

        $content .= '</div>';
      }


    }
    return $content;
  }


  function filter_comment_text_display_rating($content, $comment = null,$cid=0){


    $avg = 0;

    $comment_id = '';



    if($cid){
      $comment_id = $cid;
    }else{

      try{

        $comment_id = get_comment_ID();
      }catch (Exception $e){

      }
    }
    if($comment_id){

    }else{

      $comment_id = $comment->comment_ID;
    }
//        print_rr($comment);
//        print_rr($comment_id);


    $avg = get_comment_meta($comment_id,'dzs_star_rating',true);

//	    echo 'whaa'.$avg;
    if($avg){


      $content .= '<div class="dzs-star-rating-average">';


      $content.='<div class="clear"> </div>
        <div class="dzs-ratings-con dzs-ratings-con--content">
        <div class="dzs-ratings-con-bg"><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span></div>
        <div class="dzs-ratings-con-prog" style="width: '.( ($avg*20) ).'%;"><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span></div>
        </div>';
      $content .= '</div>';
    }

    return $content;
  }





  public function get_ratings_arr($pid){

    $ratings = array();


    try{
      $ratings = json_decode(get_post_meta($pid,'dzs_star_ratings',true),true);
    }catch(Exception $e){

    }

    if(is_array($ratings)==false){
      $ratings = array();
    }

    return $ratings;
  }



  public function get_ratings_avg_for_post($pid){

    $ratings = $this->get_ratings_arr($pid);

    $avg = 0;
    foreach ($ratings as $rat){
      $avg+=$rat;
    }

//		print_rr($ratings);


    if(count($ratings)){

      $avg/=count($ratings);
    }

    if(is_nan($avg)){
      $avg=0;
    }



    $avg = round($avg*2);


    $avg = $avg/2;

    return $avg;
  }

  public function handle_save_rating( $comment_id ) {




    if(isset($_POST['dzs_star_rating']) && $_POST['dzs_star_rating']){

      // Get comment
      $comment = get_comment( $comment_id );

      if ( ! $comment || is_wp_error( $comment ) ) {
        return;
      }

      // Update post rating by Post ID
      $pid =  $comment->comment_post_ID ;



      $ratings = $this->get_ratings_arr($pid);

//			error_log('$ratings - '.print_r($ratings,true));

      update_comment_meta($comment_id, 'dzs_star_rating',$_POST['dzs_star_rating']);
      $ratings[$comment_id] =  $_POST['dzs_star_rating'];

//			error_log('$ratings - '.print_r($ratings,true));

      update_post_meta($pid, 'dzs_star_ratings',json_encode($ratings));
    }



  }


  function handle_comment_form_logged_in_after(){



    global $post;

    if($post && $post->post_type=='dir_items'){



      wp_enqueue_script('directoryform',$this->base_url.'libs/directoryform/directoryform.js');
      wp_enqueue_style('directoryform',$this->base_url.'libs/directoryform/directoryform.css');

      /*
 * <img class="dzs-rating-star" src="<?php echo $this->base_url; ?>libs/directoryform/img/star_rating.svg"/>
 */


      ?><div class="comment-form-rating"><label for="comment"><?php echo esc_html__("Rating",'dzsdtf') ?></label>

        <input type="hidden" name="dzs_star_rating" value="0" />
        <div class="clear"> </div>
        <div class="dzs-ratings-con dzs-ratings-con--submit-comment">
            <div class="dzs-ratings-con-bg"><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span></div>
            <div class="dzs-ratings-con-prog"><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span><span class="dzs-rating-star"></span></div>
        </div>

        </div><?php
    }
  }

  function pricing_table_generate_col_pre($po) {

    $fout = '';



    $currency = get_woocommerce_currency_symbol();

//	    print_rr($po);



    $nr_days = '7';
    $extra_classes = '';


    if($po->post_name=='dzsdtf-membership-30-days'){
      $nr_days = '30';

      $extra_classes.=' premium-col';
    }

    if($po->post_name=='dzsdtf-membership-180-days'){
      $nr_days = '180';
    }


    $title = sprintf( esc_html__( "%s DAYS", 'dzsdtf' ), $nr_days );

    $regular_price = get_post_meta( $po->ID, '_regular_price', true );
    $fout          .= $this->pricing_table_generate_col( array(
      'title' => $title,
      'price' => '<span class="the-currency">'.$currency.'</span>' . $regular_price,
      'extra_classes' => $extra_classes,
      'po' => $po,
    ) );

    return $fout;
  }
  function pricing_table_generate_col($pargs, $content='') {

    $margs = array(
      'title'  => 'title',
      'price'  => '$10',
      'extra_classes'  => '',
      'po'  => '',
    );


    if ( is_array( $pargs ) ) {
      $margs = array_merge( $margs, $pargs );
    }



    $fout = '';


    $fout.='<div class="dzspt-col '.$margs['extra_classes'].'">
                            <div class="dzspt-col-inner">
                                <div class="dzspt-item title-item">
                                    '.$margs['title'].'
                                </div>
                                <div class="dzspt-item price-item">
                                    '.$margs['price'].'
                                </div>
                                <div class="dzspt-item"><strong>1</strong> copy</div>
                                <div class="dzspt-item"><strong>online</strong> access</div>
                                <div class="dzspt-item"><strong>free</strong> shipping</div>
                                <div class="dzspt-item purchase-item"><a href="'.add_query_arg(array(
        'add-to-cart'=>$margs['po']->ID,
      ),dzs_curr_url()).'" class="full-btn">'.esc_html__( "Sign up", 'dzsdtf' ).'</a></div>
                            </div>
                        </div>';

    return $fout;

  }
  function shortcode_directory_pricing_table($pargs, $content='') {

    $margs = array(
      'style'  => 'default', // -- default or round-white-bg
      'cat'  => 'parent_tags', // -- default or round-white-bg
    );


    if ( is_array( $pargs ) ) {
      $margs = array_merge( $margs, $pargs );
    }



    $fout = '';

    $fout.= '<div class="dzspt-table skin-the-grey three-in-a-row">';


    $the_slug = 'dzsdtf-membership-7-days';



    if ( $po_7_days = get_page_by_path( $the_slug, OBJECT, 'product' ) ) {
//	                    print_rr($po);

      $fout.=$this->pricing_table_generate_col_pre($po_7_days);
    }
    $the_slug = 'dzsdtf-membership-30-days';
    if ( $po_30_days = get_page_by_path( $the_slug, OBJECT, 'product' ) ) {
//	                    print_rr($po);

      $fout.=$this->pricing_table_generate_col_pre($po_30_days);
    }
    $the_slug = 'dzsdtf-membership-180-days';
    if ( $po_180_days = get_page_by_path( $the_slug, OBJECT, 'product' ) ) {
//	                    print_rr($po);

      $fout.=$this->pricing_table_generate_col_pre($po_180_days);
    }



    $fout.='
                    </div>';


    wp_enqueue_script('directoryform',$this->base_url.'libs/directoryform/directoryform.js');
    wp_enqueue_style('directoryform',$this->base_url.'libs/directoryform/directoryform.css');




    wp_enqueue_style('fontawesome', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css');



    return $fout;
  }
  function shortcode_directory_tag_display($pargs, $content='') {


    $margs = array(
      'display'  => 'default', // -- default or round-white-bg
      'style'  => 'default', // -- default or round-white-bg
      'per_row'  => '6', // -- default or round-white-bg
      'cat'  => 'parent_tags', // -- default or round-white-bg
      'classes'  => '', // -- default or round-white-bg
      'scroller_type'  => '', // -- default or round-white-bg
    );


    if ( is_array( $pargs ) ) {
      $margs = array_merge( $margs, $pargs );
    }



    $fout = '';
    $fout.='<div class="dzsdtf-tags-con-display tags-display-'.$margs['display'].' style-'.$margs['style'].' '.$margs['classes'].'">';
    $taxonomy = 'dir_items_tag';


    $main_tag_name = 'main';

    if($margs['cat']=='parent_tags'){




      $terms = get_terms( $taxonomy, array(
        'hide_empty' => false,
        'parent' => 0,
      ) );


//		    print_rr($terms);

    }else{




      $term_id = $this->sanitize_term_slug_to_id($margs['cat'], $taxonomy);



      $terms = get_terms( $taxonomy, array(
        'hide_empty' => false,
        'parent' => $term_id,
      ) );

    }




    // -- start display


    if($margs['display']=='default'){

      $fout.='<div class="dzs-row">';
    }
    if($margs['display']=='scroller'){




      $fout.='<div class="contentscroller scroller-type-'.$margs['scroller_type'].' auto-init bullets-none animate-height " data-margin="30" style="; height: auto;" data-options=\'{
    "settings_direction": "horizontal"
    ,"settings_onlyone": "off"
    ,"settings_autoHeight": "on"
    ,"per_row": "'.$margs['per_row'].'"
    ,"outer_thumbs": "#cs2"
}\'>

                    <div class="arrowsCon arrow-skin-bare" style="text-align: right;">
                        <div class="arrow-left">
                            <div class="arrow-con">
                                <i class="the-icon fa fa-long-arrow-left"></i>
                            </div>
                        </div>
                        <div class="arrow-right">

                            <div class="arrow-con">
                                <i class="the-icon fa fa-long-arrow-right"></i>
                            </div>
                        </div>
                    </div>
                    <div class="items">';
    }

    // -- display

    foreach ($terms as $term){


//	        print_rr($margs);
      $link = add_query_arg(array(
        'tag_'.$main_tag_name=>$term->slug,
      ),dzs_curr_url());
      $t_id = $term->term_id;
      $term_meta = get_option("taxonomy_$t_id");

      $parent_term_icon = '';
      if(isset($term_meta['icon'])){
        $parent_term_icon = $term_meta['icon'];
      }

      $label = $term->name;




      if($margs['display']=='default'){

        $fout.='<a href="'.$link.'" class="dzs-col-md-4 tag-display';



        if(isset($_GET['tag_'.$main_tag_name]) && $_GET['tag_'.$main_tag_name]==$term->slug){


          $fout.=' active';

        }

        $fout.='">';
        $fout.='<div class=" tag-display--inner">';




        if($parent_term_icon){

          $fout.='<i class=" the-icon-con">';
          $fout.='<i class=" the-icon fa fa-'.$parent_term_icon.'" style="';

          if(isset($term_meta['color'])){
            $fout.='color: '.$term_meta['color'].'';
          }

          $fout.='">';
          $fout.='</i>';
          $fout.='</i>';
        }

        if($parent_term_icon){
          $fout.='<span class=" the-label" >';

          $fout.=$label;
          $fout.='</span>';
        }



        $fout.='</div>';
        $fout.='</a>';
      }
      if($margs['display']=='scroller'){


        // -- scroller display

        $fout.='<a href="'.$link.'" class="csc-item ';





        if(isset($_GET['tag_'.$main_tag_name]) && $_GET['tag_'.$main_tag_name]==$term->slug){


          $fout.=' active';

        }

        $fout.='" style="text-align: center">
';
        $fout.='<div class="csc-item--inner--inner">';

        if($margs['scroller_type']=='image'){

          $fout.='<div class="the-img-con">';

          if(isset($term_meta['image'])){
            $fout.='<div class="the-img divimage" style="padding-top: 120%; background-image:url('.$term_meta['image'].')">';
            $fout.='</div>';

          }
          $fout.='</div>';
          $fout.='<h6 class="the-label-title">'.$label.'</h6>';
        }else{

          $fout.='<div class="the-bg" style=""></div>';




          $fout.='<div class="flex-abs-container">';

          if($parent_term_icon){


            $fout.='<i class=" the-icon-con">';
            $fout.='<i class=" the-icon fa fa-'.$parent_term_icon.'" style="';

            if(isset($term_meta['color'])){
//				        $fout.='color: '.$term_meta['color'].'';
            }

            $fout.='">';
            $fout.='</i>';
            $fout.='</i>';
          }




          $fout.='<h6 class="the-label-title">'.$label.'</h6>';
          $fout.='
</div>';
        }

        $fout.='
</div>';
        $fout.='
</a>';
      }
    }



    if($margs['display']=='default'){
      $fout.='
                </div>';
    }


    if($margs['display']=='scroller'){
      $fout.='
                    </div>


                </div>';
      wp_enqueue_script('contentscroller',$this->base_url.'libs/contentscroller/contentscroller.js');
      wp_enqueue_style('contentscroller',$this->base_url.'libs/contentscroller/contentscroller.css');
    }

    $fout.='
                </div>';

    wp_enqueue_script('directoryform',$this->base_url.'libs/directoryform/directoryform.js');
    wp_enqueue_style('directoryform',$this->base_url.'libs/directoryform/directoryform.css');




    wp_enqueue_style('fontawesome', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css');

    return $fout;


  }
  function shortcode_directory_filter_tags($pargs, $content='') {


    $margs = array(
      'style'  => 'default', // -- default or round-white-bg
    );


    if ( is_array( $pargs ) ) {
      $margs = array_merge( $margs, $pargs );
    }



    $fout = '';



    $fout.='<ul class="parent-cats-shower">';



    if(isset($_GET) && is_array($_GET)){
      foreach ($_GET as $getlab =>$getval){

        $lab = '';

        $val = '';
        $val = $getval;
        if($getlab=='directory_s'){
          $lab = esc_html__("search",'dzsdtf');





        }


        if(strpos($getlab,'tag_')===0){



          $tag_slug = str_replace('tag_','',$getlab);



          $parent_term = get_term_by('slug',$tag_slug, $this->name_port_item_tag);

//                print_rr($parent_term);



          $lab = $parent_term->name;


          if($parent_term && isset($parent_term->term_id)){

            $terms = get_terms(array(
              'taxonomy'=>$this->name_port_item_tag,
              'parent'=>$parent_term->term_id,
              'hide_empty' => false,
            ));



            foreach ($terms as $ti){
              if($ti->slug==$getval){
                $lab = $ti->name;
              }
            }
          }





        }




        $lab = strtolower($lab);




        if($lab && $val){
          $fout.='<li class=""><span><a href="'.esc_url( remove_query_arg( $getlab ) ).'" class="close-filter"><i class="fa fa-times-circle" aria-hidden="true"></i></a> '.'<span class="the-label">'.$lab.':</span> '.'<span class="the-value">'.$val.'</span>'.'<span></li>';
        }
      }
    }


    $fout.='</ul>';


    return $fout;

  }

  function shortcode_directory_search($pargs, $content=''){


    $margs = array(
      'style' => 'default', // -- default or round-white-bg
      'fields' => 'search,button', // -- fields for example "search,tag_projects,button"
      'class' => '',// -- extra classes
      'classes' => '',// -- extra classes
      'extra_classes' => '', // -- extra classes
      'align' => 'left', // -- align "left" or "right"



    );


    if(is_array($pargs)){
      $margs = array_merge($margs,$pargs);
    }

    $fout = '';


    $fout.='<div class="directory-search style-'.$margs['style'].' '.$margs['classes'].' '.$margs['extra_classes'].'"';


    $fout.=' style="';


    if($margs['align']=='right'){
      $fout.=' text-align: right;';
    }

    $fout.='"';

    $fout.='>';



    $fout.='<form class="directory-search-form">';


    $fields_arr = explode(',',$margs['fields']);

    foreach ($fields_arr as $fi){

//		    print_rr($fi);



      if($fi=='search'){


        $val = '';


        $lab = 'directory_s';


        if(isset($_GET[$lab]) && $_GET[$lab]){
          $val = $_GET[$lab];
        }



        $fout.='<input type="text" name="'.$lab.'" class="search-field search-input search-element"';
        $fout.=' placeholder="'.esc_html__("Search").'..."';
        $fout.=' value="'.$val.'"';
        $fout.='/>';
      }

      if(strpos($fi,'tag_')===0){



        $tag_slug = str_replace('tag_','',$fi);



        $parent_term = get_term_by('slug',$tag_slug, $this->name_port_item_tag);

//                print_rr($parent_term);


        if($parent_term){

          $arr_opts = array(
            'placeholder'=>$parent_term->name,
          );





          $terms = get_terms(array(
            'taxonomy'=>$this->name_port_item_tag,
            'parent'=>$parent_term->term_id,
            'hide_empty' => false,
          ));

          $opts = array(
            array(
              'label'=>$parent_term->name,
              'value'=>'',
              'icon'=>'',
            )
          );

          $sw_has_icon = false;

          foreach ($terms as $ti){
            $aux = array(
              'label'=>$ti->name,
              'value'=>$ti->name,
              'icon'=>'',
            );



            $t_id = $ti->term_id;
            if($t_id){

              // retrieve the existing value(s) for this meta field. This returns an array
              $term_meta = get_option("taxonomy_$t_id");

              if(isset($term_meta['icon'])){
                $aux['icon'] = $term_meta['icon'];
                $sw_has_icon= true;
              }

            }


            array_push($opts,$aux);




          }

//                print_rr($opts);


          $val = '';


          if(isset($_GET[$fi]) && $_GET[$fi]){
            $val = $_GET[$fi];
          }




          $class = 'dzs-style-me skin-beige search-element';

          if($sw_has_icon){
            $class.=' opener-list skin-tooltip';
          }
          $fout.=DZSHelpers::generate_select($fi, array(
            'options'=>$opts,
            'seekval'=>$val,
            'class'=>$class,
            'extraattr'=>' data-options=\''.json_encode($arr_opts).'\'',
          ));


          if($sw_has_icon){
            $fout.='                    <ul class="dzs-style-me-feeder">';


            foreach ($opts as $opt){
              $fout.='<li >';

              if($opt['icon']){
                $fout.='<i class="the-icon fa fa-'.$opt['icon'].'"></i>';
              }

              $fout.='<span class="the-label">'.$opt['label'].'</span></li>';
            }

            $fout.='
                    </ul>';
          }

        }

      }

      if($fi=='button'){
        $fout.='<button class="search-element search-submit"';
        $fout.='>';
        $fout.=esc_html("Search",'dzsdtf');
        $fout.='</button>';
      }
    }






    $fout.='</form>';


    $fout.='</div>';







    wp_enqueue_script('directoryform',$this->base_url.'libs/directoryform/directoryform.js');
    wp_enqueue_style('directoryform',$this->base_url.'libs/directoryform/directoryform.css');




    wp_enqueue_style('fontawesome', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css');

    wp_enqueue_script('dzs.selector',$this->base_url.'libs/dzsselector/dzsselector.js',array('jquery'));
    wp_enqueue_style('dzs.selector',$this->base_url.'libs/dzsselector/dzsselector.css');



    return $fout;
  }

  function get_current_user_id() {
    if ( ! function_exists( 'wp_get_current_user' ) )
      return 0;
    $user = wp_get_current_user();
    return ( isset( $user->ID ) ? (int) $user->ID : 0 );
  }
  function woocommerce_order_status_completed( $order_id ) {
    error_log( "Order complete for order $order_id", 0 );


    // Get an instance of the WC_Order object (same as before)
    $order = wc_get_order( $order_id );

    $order_data = $order->get_data(); // The Order data

    error_log(print_r($order_data,true));
    $order_timestamp_completed = $order_data['date_completed']->getTimestamp();
    error_log('get $order_timestamp_completed item -> '.print_r($order_timestamp_completed,true));




    $items = $order->get_items();
//		error_log(print_r($items,true));

    foreach ( $items as $item ) {
      $product_name = $item->get_name();
      $product_id = $item->get_product_id();
      $product_variation_id = $item->get_variation_id();


      $item_data = $item->get_data();

      error_log(print_r($item_data,true));
      error_log('$product_name - '.print_r($product_name,true).' ||| $product_id - '.print_r($product_id,true));
//			error_log('$po - '.print_r(,true));

      $po = get_post($product_id);


      $today_ts = $order_timestamp_completed;
      $updated_ts = $today_ts;



      if($po->post_name=='dzsdtf-membership-7-days'){
//				$today = date("F j, Y, g:i a",$order_timestamp_completed);
        $updated_ts = strtotime('+7 days', $today_ts);


      }
      if($po->post_name=='dzsdtf-membership-60-days'){
//				$today = date("F j, Y, g:i a",$order_timestamp_completed);
        $updated_ts = strtotime('+1 months', $today_ts);


      }
      if($po->post_name=='dzsdtf-membership-180-days'){

        $today = date("F j, Y, g:i a",$order_timestamp_completed);
        error_log('order placed on '.$today);

//				$today = date("F j, Y, g:i a",$order_timestamp_completed);
        $updated_ts = strtotime('+6 months', $today_ts);
        error_log('order expires on '.$updated_ts);
        $today = date("F j, Y, g:i a",$updated_ts);
//				error_log('order expires on '.$today);


      }
      update_option('dzsdtf_membership_expires_for_'.$this->get_current_user_id(), $updated_ts);

    }
  }

  function get_directory_thumb($id, $pargs=array()){



    $margs = array(
      'size' => 'full',
    );


    if(is_array($pargs)){
      $margs = array_merge($margs,$pargs);
    }


    $fout = get_post_meta($id,'dzsdtf_meta_thumb',true);



//		global $content_width;
//		$content_width = 1500;

    if(is_numeric($fout)){

      $fout = wp_get_attachment_image_src(get_post_thumbnail_id($id),$margs['size']);
    }



    if($fout==''){
//            $potid = get_the_post_thumbnail($id);


      $fout = wp_get_attachment_image_src(get_post_thumbnail_id($id), $margs['size'],false);

//            print_rr($fout);

      if($fout && $id && $margs['size']!='full'){

//                echo '$content_width - '.$content_width;

//	            print_rr($margs);
//	            print_rr($fout);
      }
    }


    if(is_array($fout) && isset($fout[0])){
      $fout = $fout[0];
    }
    return $fout;
  }


  function parse_ultibox_col($collab, $ultibox_item_arr, $po){

    $dir_extra_html = '';

//		echo '$collab - '.$collab;
    include("class_parts/parse_ultibox_col.php");
    return $dir_extra_html;

  }

  function get_query_var($url,$part){
    $parts = parse_url($url);
    parse_str($parts['query'], $query);

//		echo 'query - '; print_rr($query);


    if(isset($query[$part])){

      return $query[$part];
    }

    return '';
  }
  function sanitize_to_yt_id($arg){


    if($this->get_query_var($arg,'v')){

      return $this->get_query_var($arg,'v');
    }

    if(strpos($arg,'youtu.be')){

      $arr = explode('youtu.be/',$arg);

      return $arr[1];
    }


    return $arg;

  }

  function closetags($html) {
    preg_match_all('#<([a-z]+)(?: .*)?(?<![/|/ ])>#iU', $html, $result);
    $openedtags = $result[1];
    preg_match_all('#</([a-z]+)>#iU', $html, $result);
    $closedtags = $result[1];
    $len_opened = count($openedtags);
    if (count($closedtags) == $len_opened) {
      return $html;
    }
    $openedtags = array_reverse($openedtags);
    for ($i=0; $i < $len_opened; $i++) {
      if (!in_array($openedtags[$i], $closedtags)) {
        $html .= '</'.$openedtags[$i].'>';
      } else {
        unset($closedtags[array_search($openedtags[$i], $closedtags)]);
      }
    }
    return $html;
  }
  function shortcode_directory_form($pargs, $content=''){


    $margs = array(
      'display_type' => 'list',// -- "list" or "grid" or "grid-2" or "scroller" or "map" or "horizontal"
      'grid_skin' => 'skin-forwall', // -- grid skin
      'grid_extra_classes' => '', // -- extra classes for display grid
      'tooltip_filters_show' => '', // -- select which information to display on the tooltip, for example "thumb,title,content,tag_houses,tag_villas,date"
      'cols' => '3-cols', // -- number of columns
      'parent_filter' => '', // -- filter tag ( slug )
      'posts_per_page' => '', // -- posts per page
      'table_fields' => '', // -- select which information to display, for example "thumb,title,content,tag_houses,tag_villas,date"
      'desc_max_chars' => 'default', // -- input a number for number of chars
      'item_links_to' => 'item', // -- "item" or "lightbox" or "none"
      'grid_type' => '', // -- grid type , "image" or "default"
      'thumb_size' => 'default', // "default" or "400,300" etc.
      'zoom' => '12', // -- for display map, zoom ratio on google maps
      'lat' => '', // -- for display map, start latitude
      'long' => '', // -- for display map, start longitude
      'orderby' => '', // -- "date" or "rand" or "title"
      'extra_classes' => '', // -- extra css classes on the directory display
      'wpqargs' => '', // -- extra query args
      'cat_slug' => '', // -- the category in which to retrieve directory entries
      'cat' => '',
    );


    if(is_array($pargs)){
      $margs = array_merge($margs,$pargs);
    }




    if($margs['desc_max_chars']=='default'){
      $margs['desc_max_chars'] = 70;
    }


    $term_id = $this->sanitize_term_slug_to_id($margs['cat_slug'],'dir_items_cat');

//		echo '$term_id - '.$term_id;


    $fout = '';

















    $term_id_nr = ($term_id);

    /** @var $args */
    $wpqargs = array();
    $meta_key = 'dzs_meta_order_for_term_'.$term_id_nr;

    $wpqargs['post_type']=$this->name_port_item;
    $wpqargs['posts_per_page']='-1';
    $wpqargs['post_status']='publish';
    $wpqargs['tax_query']=array();




    if($term_id){

//			$wpqargs['orderby']=array(
//                'meta_key' => 'DESC',
//                'meta_value_num' => 'DESC',
//                'date' => 'DESC'
//            );
//			$wpqargs['meta_query']=array(
//				'relation' => 'OR',
//				array(
//					'key'=>$meta_key,
//					'compare' => 'EXISTS'
//				),
//				array(
//					'key'=>$meta_key,
//					'compare' => 'NOT EXISTS'
//				)
//			);
    }else{

    }


    // -- force date ordering on search
    if($margs['orderby'] && isset($_GET['directory_s'])==false){

      $wpqargs['orderby']=$margs['orderby'];
    }else{

      $wpqargs['orderby']=array('date' => 'DESC' );
    }

    $wpqargs['order']="DESC";


    if(isset($_GET['directory-page']) && $_GET['directory-page']){
      $wpqargs['paged']=$_GET['directory-page'];
    }


    if($margs['posts_per_page']){
      $wpqargs['posts_per_page'] = $margs['posts_per_page'];
    }else{
      $wpqargs['posts_per_page'] = '-1';
    }

    if($margs['posts_per_page']=='all'){

      $wpqargs['posts_per_page'] = '-1';
    }


    $paged = '1';

    if($wpqargs['posts_per_page']!='-1'){
      if(isset($_GET['dzsdtf_paged'])){
        $paged = $_GET['dzsdtf_paged'];
      }
      $wpqargs['paged'] = $paged;
    }


    $the_cat_id = '';
    $the_cat = null;
    $the_cat_children = array();
    $arr_cats_ids = array();
    $arr_tags_ids = array();
    $arr_tags = array();
    $arr_cats = array();

    if($margs['cat'] && $margs['cat']!='all'){


      $taxonomy_name = $this->name_port_item_cat;


      $arr_cats = explode(',', $margs['cat']);
      $arr_cats_ids = array_merge(array(), $arr_cats);


      $new_cat = $margs['cat_slug'];

      foreach ($arr_cats as $lab=>$term_id){

        if(is_numeric($term_id)){

        }else{

          $term = get_term_by('slug', $term_id, $taxonomy_name);

          if($term){
            $arr_cats[$lab] = $term->term_id;
          }

        }

      }

      if ($wpqargs['post_type'] == 'post') {
        $wpqargs['cat'] = $margs['cat'];
      }


//			print_rr($arr_cats);


//            print_rr($wpqargs);
      if ($wpqargs['post_type'] == $this->name_port_item) {

//			    echo 'what what in the ..';


        // -- TODO: maybe just one category
        foreach ($arr_cats as $lab=>$val){
          $arr_cats_ids[$lab]= $this->sanitize_term_slug_to_id($val,$this->name_port_item_tag);


        }
//                echo 'arr_cats_ids - '; print_rr($arr_cats_ids);


        array_push($wpqargs['tax_query'],					array(
            'taxonomy' => $taxonomy_name,
            'field' => 'id',
            'terms' => $arr_cats_ids,
          )
        );
//				$wpqargs['tax_query'] = array(
//					array(
//						'taxonomy' => $taxonomy_name,
//						'field' => 'id',
//						'terms' => $arr_cats_ids,
//					)
//				);
        $the_cat = get_term($margs['cat'],$taxonomy_name);




        $the_cat_id = $margs['cat'];
        $term_id = $the_cat_id;


        if(is_numeric($term_id)){

        }else{

          $term = get_term_by('slug', $margs['cat'], $taxonomy_name);

          if($term){
            $term_id = $term->term_id;
          }

        }


      }



    }

    // -- end category tax_query



    if($margs['parent_filter'] && $margs['parent_filter']!='all'){


      $taxonomy_name = $this->name_port_item_tag;


      $arr_tags = explode(',', $margs['parent_filter']);
      $arr_cats_ids = array_merge(array(), $arr_cats);




      foreach ($arr_tags as $lab=>$term_id){

        if(is_numeric($term_id)){

        }else{

          $term = get_term_by('slug', $term_id, $taxonomy_name);

          if($term){
            $arr_tags[$lab] = $term->term_id;
          }

        }

      }

      if ($wpqargs['post_type'] == 'post') {
        $wpqargs['cat'] = $margs['cat'];
      }


//			print_rr($arr_cats);


//            print_rr($wpqargs);
      if ($wpqargs['post_type'] == $this->name_port_item) {

//			    echo 'what what in the ..';
        foreach ($arr_tags as $lab=>$val){
          $arr_tags_ids[$lab]= $this->sanitize_term_slug_to_id($val,$this->name_port_item_tag);


        }
//                echo 'arr_cats_ids - '; print_rr($arr_cats_ids);


        if(isset($wpqargs['tax_query']) && $wpqargs['tax_query'] && is_array($wpqargs['tax_query'])){


          array_push($wpqargs['tax_query'],		                array(
              'taxonomy' => $taxonomy_name,
              'field' => 'id',
              'terms' => $arr_tags_ids,
            )
          );
        }else{

          $wpqargs['tax_query'] = array(
            array(
              'taxonomy' => $taxonomy_name,
              'field' => 'id',
              'terms' => $arr_tags_ids,
            )
          );
        }





      }



    }

    // -- end tags

//		echo 'wpqargs - '; print_rr($wpqargs);


    // -- start the LOOP
    $custom_args_wpqargs = array();
    // -- lets parse custom wp query args

    if($margs['wpqargs']){

      $margs['wpqargs'] = html_entity_decode($margs['wpqargs']);
    }
    parse_str($margs['wpqargs'],$custom_args_wpqargs);



    $arr_tooltip_filters_show = array();
    if($margs['tooltip_filters_show']){

      $arr = explode(',',$margs['tooltip_filters_show']);

//            print_rr($arr);

      foreach ($arr as $arri){

        $term = get_term_by('slug',$arri,$this->name_port_item_tag);

//                print_rr($term);

        if($term){

          $aux = array(

            'label'=>$term->name,
            'slug'=>$term->slug,
          );

          array_push($arr_tooltip_filters_show, $aux);
        }
      }
    }

    if (!isset($custom_args_wpqargs) || $custom_args_wpqargs == false || is_array($custom_args_wpqargs) == false) {
      $custom_args_wpqargs = array();
    }
    $wpqargs = array_merge($wpqargs,$custom_args_wpqargs);


    if(isset($_GET['directory_s']) && $_GET['directory_s']){
      $wpqargs['s']=$_GET['directory_s'];
    }




    $sw_found_tags = false;
    $found_tags_arr = array();




    foreach ($_GET as $lab => $val){





      if(strpos($lab,'tag_')===0){


        if($val){

          array_push($found_tags_arr,$val);

          $sw_found_tags = true;
        }
      }
    }

    if($sw_found_tags){

      $wpqargs['tax_query'] = array(
        array(

          'taxonomy'=>$this->name_port_item_tag,
          'field'=>'slug',

          'terms'=> $found_tags_arr,
        )
      );
    }

//		echo 'wpqargs - '; print_rr($wpqargs);
    $query = new WP_Query($wpqargs);


//		print_rr($query);

    $pos = $query->posts;

    $dir_extra_html = ''; // -- usually lightbox items


    $its = array();


    if($margs['thumb_size']=='default'){
      if($margs['display_type']=='grid') {
        $margs['thumb_size'] = '320,320';
        $margs['thumb_size'] = 'dzsdtf-grid-size';
      }
    }

    if($margs['thumb_size']=='default'){
      $margs['thumb_size'] = 'full';
    }
    if(strpos($margs['thumb_size'],',')){
      $margs['thumb_size']=explode(',',$margs['thumb_size']);
    }

    foreach ($pos as $po){
//		    print_rr($po);

      $arpo = $this->get_post_meta_all($po->ID);

//		    print_rr($arpo);





//			echo "\n____\n";
//			echo '$po->post_content - '.$po->post_content;
//			echo "\n____\n";
//			echo "wp_kses - ".wp_kses((DZSHelpers::wp_get_excerpt(-1,array(
//						'content'=>$po->post_content,
//						'maxlen'=>$margs['desc_max_chars'],
//						'readmore_markup'=>' <a href="'.get_permalink($po->ID).'">[ ... ]</a>',
//						//		                    'aftercutcontent_html'=>' [...]',
//						'readmore'=>'auto',
//					)))
//					,$this->allowed_tags
//				);
//			echo "\n____\n";


      $auxit = array(
        'id'=>$po->ID,
        'lat'=>get_post_meta($po->ID,'dzsdtf_meta_lat',true),
        'long'=>get_post_meta($po->ID,'dzsdtf_meta_long',true),
        'title'=>$po->post_title,
        'permalink_class'=>'', // -- the extra class of the permalink ( for example for ultibox we need ultibox-delegated class
        'permalink_extraattr'=>'', // -- class to the permalink hmm
        'permalink_selected'=>'default', // -- the selected permalink type - lightbox / item / none
        'permalink_post'=>get_permalink($po->ID),
        'date'=>get_the_time('d M \'y', $po->ID),
        'all_content'=>$po->post_content,


        'content'=>$this->closetags(wp_kses(wpautop(DZSHelpers::wp_get_excerpt(-1,array(
              'content'=>$po->post_content,
              'maxlen'=>$margs['desc_max_chars'],
              'readmore_markup'=>' <a href="'.get_permalink($po->ID).'">[ ... ]</a>',
//		                    'aftercutcontent_html'=>' [...]',
              'readmore'=>'auto',
            ))
            )
            ,$this->allowed_tags
          )
        ),
        'thumb'=>$this->get_directory_thumb($po->ID, array(
          'size'=>$margs['thumb_size']
        )),
        'thumb_full'=>$this->get_directory_thumb($po->ID, array(
          'size'=>'full'
        )),
        'item_extra_html'=>'', // -- extra html after item
      );





      if($margs['item_links_to']=='lightbox'){
        $auxit['permalink_selected']='#';
        $auxit['permalink_class']='ultibox-item-delegated';
        $auxit['permalink_extraattr']=' data-source="#wooow-for-ultibox'.$po->ID.'" data-inline-move="off" data-suggested-width="100vw" data-suggested-height="auto" data-scaling="fill" data-biggallery="ulti1"';


        wp_enqueue_script('ultibox',$this->base_url.'libs/ultibox/ultibox.js');
        wp_enqueue_style('ultibox',$this->base_url.'libs/ultibox/ultibox.css');


        $taxonomy_name = $this->name_port_item_tag;



        $terms = wp_get_post_terms( $po->ID, $taxonomy_name, array() );


//			    print_rr($terms);

        $parent_term_icon = '';
        $parent_term_name = '';


        if(is_array($terms) && isset($terms[0])){







//			        echo '$t_id - '.$t_id;

          $t_id = 0;

          $final_term = $terms[0];
          if($terms[0]->parent){

            $t_id = $terms[0]->parent;

            $final_term = get_term($t_id,$taxonomy_name);
          }else{

            $t_id = $terms[0]->term_id;
          }


          if($t_id){

            // retrieve the existing value(s) for this meta field. This returns an array
            $term_meta = get_option("taxonomy_$t_id");

            if(isset($term_meta['icon'])){
              $parent_term_icon = $term_meta['icon'];
            }

            $parent_term_name = $final_term->name;
          }

//				    print_rr($term_meta);
        }



        $dir_extra_html.='<div id="wooow-for-ultibox'.$po->ID.'" class="grey-bg wow-page skin-baza show-in-ultibox ">
        <div class="wow-page--inner">





            <div class="image-bg-con" style="">
                <div class="image-bg divimage" style="background-image: url('.$auxit['thumb'].')">

                </div>
                <div class="image-bg-overlay"></div>
                ';







        $dir_extra_html.='

            <div class="dzs-container container-inset container-meta-controls">
                <div class="dzs-row row-for-ultibox">
                    <div class="wow-avatar divimage" style=\'background-image: url("'.$auxit['thumb'].'")\'></div>

                    <h3 class="the-wow-title">'.$po->post_title.'</h3>';



        if($parent_term_name){
          $dir_extra_html.='<div class="tag-box to-the-left"><i class="the-icon fa fa-'.$parent_term_icon.'"></i><span class="the-label">'.$parent_term_name.'</span></div>';
        }



        $dir_extra_html.='

                    

                    <div class="tags-boxes to-the-right">

';

//			    print_rr($po);


        $newDate = date("d-m-Y", strtotime($po->post_date));




        $dir_extra_html.='<div class="tag-box "><i class="the-icon fa fa-calendar-o"></i><span class="the-label">'.$newDate.'</span></div>';

        $dir_extra_html.='
';


        $avg = $this->get_ratings_avg_for_post($po->ID);


//	        echo '$avg - '.$avg;
        if($avg>0) {

          // Build rating HTML


          $dir_extra_html .= '<div class="tag-box big-tag-box " style="background-color: #00a99d">'.( $avg  ).'</div>';

        }



        $dir_extra_html.='
                    </div>
                </div>
            </div><!-- end .container-inset-->';


        $dir_extra_html.='
            </div>

';

        $dir_extra_html.='
                <div class="dzs-container container-controls ">
                    <div class="dzs-row row-for-ultibox">
                        <div class="col-md-12">
                            <span  class="ultibox-control ultibox-prev-btn ultibox-gallery-arrow--left"><i class="fa fa-caret-left" aria-hidden="true"></i></span>
                            <span  class="ultibox-control ultibox-next-btn ultibox-gallery-arrow--right"><i class="fa fa-caret-right" aria-hidden="true"></i></span>
                            <span  class="ultibox-control ultibox-close-btn" style="margin-left: auto;"><span class="the-label">CLOSE</span><i class="fa fa-times" aria-hidden="true"></i></span>
                        </div>
                    </div>
                </div>
                <hr>';



        $dir_extra_html.='


            <div class="dzs-container">
                <div class="dzs-row row-for-ultibox">
                    <div class="col-md-6">';



        $ultibox_item_arr = get_option('dzsdtf_ultibox_item');

//			    print_rr($ultibox_item_arr);



        $dir_extra_html.=$this->parse_ultibox_col('col1', $ultibox_item_arr, $po);

        $dir_extra_html.='




                    </div>
                    <div class="col-md-6">

';

        $dir_extra_html.=$this->parse_ultibox_col('col2', $ultibox_item_arr, $po);

        $dir_extra_html.='


                    </div>
                </div>
            </div>


        </div>






    </div>';


      }
      if($margs['item_links_to']=='none'){
        $auxit['permalink_selected']='';
      }


      if($auxit['permalink_selected']=='default'){
        $auxit['permalink_selected']=$auxit['permalink_post'];
      }


      if(get_post_meta($po->ID,'dzsdtf_custom_link',true)){
        $auxit['permalink_selected'] = get_post_meta($po->ID,'dzsdtf_custom_link',true);
      }


      array_push($its,$auxit);
    }






//        echo 'its - '; print_rr($its);


//		responsive-mode

    $fout.='<div class="directory-form auto-init  directory-form-display-'.$margs['display_type'].'" >';


    if(is_array($its) && count($its)){

    }else{


      if($margs['display_type']!='map' && $margs['display_type']!='list') {

        // -- no point for map and list
        $fout .= '<div class="warning">' . esc_html__( "no results... search again!", 'dzsdtf' ) . '</div>';
        $fout .= '</div><!-- end .directory-form-->';
      }else{
        $fout .= '</div><!-- end .directory-form-->';
      }

      return $fout;
    }





    // -- grid start

    if($margs['display_type']=='grid'){


//		    print_rr($margs);
//		    print_rr($its);


      wp_enqueue_script('zfolio',$this->base_url.'libs/zfolio/zfolio.js');
      wp_enqueue_style('zfolio',$this->base_url.'libs/zfolio/zfolio.css');

      $fout.='<div class="flex-table">';


//			print_rr($margs);


      $fout.='<div class="zfolio '.$margs['grid_skin'].' '.$margs['grid_extra_classes'].' auto-init delay-effects dzs-layout--'.$margs['cols'].'" data-margin="10" data-options=\'{
"design_item_thumb_height":"1.5"
,"item_extra_class":""
,"settings_useLinksForCategories":"off"
,"selector_con_skin":"none"
,"settings_useLinksForCategories_enableHistoryApi":"on"
,"excerpt_con_transition": "wipe"';


      if($margs['grid_type']=='scroller'){
        $fout.=',"settings_mode":"'.$margs['grid_type'].'"';
      }
      if($margs['grid_type']=='scroller'){
        $fout.=',"scroller_settings":{';
        $fout.='"settings_autoHeight":"on"';
        $fout.='}';
      }

      $fout.='
}\'>';



      $fout.='<div class="items ">';
      $fields_arr = explode(',',$margs['table_fields']);



//			print_rr($margs);

      // -- still grid





      foreach ($its as $it){

//			    print_rr($it);
        $fout.='<div class="zfolio-item zfolio-item-id-7 " data-thumbnail="'.$it['thumb'].'">


                                <div  class="zfolio-item--inner custom-a "  data-biggallery="zfolio0" data-lightbox-title="Default 1" data-type=""> <div class="zfolio-item--inner--inner"><div class="zfolio-item--inner--inner--inner">
                                    <div class="item-meta">

                                        <div class="the-title">';

        $fout.='<a class=" '.$it['permalink_class'].'" href="'.$it['permalink_selected'].'" '.$it['permalink_extraattr'].'>';
        $fout.=$it['title'];
        $fout.='</a>';



        $fout.='</div>';
        $fout.='<div class="the-desc">';


        $sw_added_tags_con = false;
        foreach ($fields_arr as $fa){


          $lab = '';
          $val = '';

//			        print_rr($it);


          if($fa=='content'){
            $fout.='<div class="the-content-excerpt">'.$it['content'].'</div>';
          }


          if(strpos($fa,'meta')===0){


            $tag_slug_stripped = str_replace('meta_','',$fa);
            $tag_slug = str_replace('meta_','dzsdtf_meta_',$fa);


            if(get_post_meta($it['id'],$tag_slug,true)){

              $fout.='<div class="meta-field meta-field-for-'.$tag_slug_stripped.'">'.get_post_meta($it['id'],$tag_slug,true).'</div>';
            }




          }


          if(strpos($fa,'tag_')===0){


            $tag_slug = str_replace('tag_','',$fa);



            $parent_term = get_term_by('slug',$tag_slug, $this->name_port_item_tag);

//				        print_rr($parent_term);


            if($parent_term){

              $lab = $parent_term->name;

              $term_list = wp_get_post_terms($it['id'], $this->name_port_item_tag, array(
                "fields" => "all",
                "parent" => $parent_term->term_id,
              ));


              foreach ($term_list as $tli){
                if($val){
                  $val.=',';
                }

                $val = $tli->name;
              }

//				        print_rr($term_list);
            }


          }


          if($fa=='parent_tags'){

            $taxonomy = 'dir_items_tag';



            $terms = wp_get_post_terms($it['id'], $taxonomy);


//			print_rr($terms);

            $link = '';
            $term_name = '';
            $term_color = '';



            if(is_array($terms) && count($terms)){

              $link = get_term_link($terms[0]->term_id);

              $term_name = $terms[0]->name;

              $t_id = $terms[0]->term_id;

              // retrieve the existing value(s) for this meta field. This returns an array
              $term_meta = get_option("taxonomy_$t_id");

              if($term_meta['color']){
                $term_color = $term_meta['color'];
              }

              if($terms[0]->parent){

                $link = get_term_link($terms[0]->parent);
//	                            print_rr($link);
                $parent_term = get_term($terms[0]->parent);
//print_rr($parent_term);
                $term_name = $parent_term->name;
//	                            echo '$term_name - '; print_rr($term_name);

                $t_id = $terms[0]->parent;

                // retrieve the existing value(s) for this meta field. This returns an array
                $term_meta = get_option("taxonomy_$t_id");


//	                            print_rr($term_meta);

                if($term_meta['color']){
                  $term_color = $term_meta['color'];
                }
              }

            }
            if($link && is_string($term_name)){

              $fout.='<div class="parent-tags">';
              $fout.= '<a href="'.$link.'" style="';
              if($term_color){
                $fout.='background-color: '.$term_color.';';
              }
              $fout.='">'.$term_name.'</a>';
              $fout.= '</div>';
            }

          }



          if($lab && $val){

            if($sw_added_tags_con==false){

              $fout.='<div class="filters-con">';
            }

            $fout.='<h6>'.$lab.'</h6>';
            $fout.='<div class="filter-content">'.$val.'</div>';

            if($sw_added_tags_con==false){

              $fout.='</div>';
              $sw_added_tags_con = true;
            }
          }
        }


        foreach ($arr_tooltip_filters_show as $arri){
//	                echo 'arri - '; print_rr($arri);

          $main_term = get_term_by('slug',$arri['slug'],$this->name_port_item_tag);


//		            echo '$main_term - '; print_rr($main_term);
//	                print_rr($it);
          $terms = wp_get_post_terms($it['id'],$this->name_port_item_tag,array(

            'parent'=>$main_term->term_id
          ));

//	                echo 'terms - '; print_rr($terms);

          $aux['content'] = '';
          $aux['content'].='<h6>'.$arri['label']."</h6>";
          if(is_array($terms) && isset($terms[0])){
            $aux['content'].='<p class="filter-content">';

            $aux['content'].=$terms[0]->name;
            $aux['content'].='</p>';
          }



        }






        $fout.='</div><!-- end .the-desc -->

                                    </div><!--end item-meta-->

                                </div>
                                </div>


                                </div><!--end zfolio-item--inner--><div class="the-overlay-anchor">
                            </div>

                            </div>';


























        $fout.=$it['item_extra_html'];
      }

      // -- end foreach




      $fout.='</div>'; // -- end items
      $fout.='</div>';
      $fout.='</div>';



    }





    // -- horizontal start

    if($margs['display_type']=='horizontal'){


//		    print_rr($margs);
//		    print_rr($its);


      wp_enqueue_script('zfolio',$this->base_url.'libs/zfolio/zfolio.js');
      wp_enqueue_style('zfolio',$this->base_url.'libs/zfolio/zfolio.css');

      $fout.='<div class="dzsdtf-horizontal-con">';



      $fout.='<div  class="dzsdtf-horizontal" data-margin="10" data-options=\'{
"design_item_thumb_height":"1"
,"item_extra_class":""
,"settings_useLinksForCategories":"off"
,"selector_con_skin":"none"
,"settings_useLinksForCategories_enableHistoryApi":"on"
,"excerpt_con_transition": "wipe"
}\'>';



      $fout.='<div class="items ">';
      $fields_arr = explode(',',$margs['table_fields']);




      // -- still horizontal





      foreach ($its as $it){




        $fout.='<div class="horizontal-item">';
        $fout.='<div class="horizontal-item--inner">';


        $thumb = $this->get_directory_thumb($it['id']);


        if($thumb){

          $fout.='<div class="horizontal-item--thumb">';
          $fout.='<div class="horizontal-item--thumb-img divimage" style="background-image:url('.$thumb.'); ">';






          $fout.='</div>';
          $fout.='</div>';
        }


        $content = '';

        if($it['content']){
          $content.=$it['content'];
        }








        $sw_added_tags_con = false;
        foreach ($fields_arr as $fa){


          $lab = '';
          $val = '';

//			        print_rr($it);



          if(strpos($fa,'tag_')===0){


            $tag_slug = str_replace('tag_','',$fa);



            $parent_term = get_term_by('slug',$tag_slug, $this->name_port_item_tag);

//				        print_rr($parent_term);


            if($parent_term){

              $lab = $parent_term->name;

              $term_list = wp_get_post_terms($it['id'], $this->name_port_item_tag, array(
                "fields" => "all",
                "parent" => $parent_term->term_id,
              ));


              foreach ($term_list as $tli){
                if($val){
                  $val.=',';
                }

                $val = $tli->name;
              }

//				        print_rr($term_list);
            }


          }



          if($lab && $val){

            if($sw_added_tags_con==false){

              $content.='<div class="filters-con">';
            }

            $content.='<h6>'.$lab.'</h6>';
            $content.='<div class="filter-content">'.$val.'</div>';

            if($sw_added_tags_con==false){

              $content.='</div>';
              $sw_added_tags_con = true;
            }
          }
        }


        foreach ($arr_tooltip_filters_show as $arri){
//	                echo 'arri - '; print_rr($arri);

          $main_term = get_term_by('slug',$arri['slug'],$this->name_port_item_tag);


//		            echo '$main_term - '; print_rr($main_term);
//	                print_rr($it);
          $terms = wp_get_post_terms($it['id'],$this->name_port_item_tag,array(

            'parent'=>$main_term->term_id
          ));

//	                echo 'terms - '; print_rr($terms);


          $content.='<h6>'.$arri['label']."</h6>";
          if(is_array($terms) && isset($terms[0])){
            $aux['content'].='<p class="filter-content">';

            $content.=$terms[0]->name;
            $content.='</p>';
          }



        }






        $fout.='<div class="horizontal-item--cont">';


        $permalink_to_post = $it['permalink_post'];


        $fout.='<a href="'.$permalink_to_post.'">';
//				$fout.=$it['title'];
        $fout.='<h4 class="horizontal-title">'.$it['title'].'</h4>';
        $fout.='</a>';







        $fout.='<div class="paragraph horizontal-content">'.$content.'</div>';
        $fout.='<div class="buttons-con">'.'<a class="dzs-button btn-style-default color-normal-highlight color-over-dark '.$it['permalink_class'].'" href="'.$it['permalink_selected'].'"  '.$it['permalink_extraattr'].'><span class="the-text">'.esc_html__("Continue reading").' &rarr;</span></a></div>';


        $fout.='</div>';


        $fout.='</div>';



        $fout.=$it['item_extra_html'];
        $fout.='</div>';




































      }

      // -- end foreach





      $fout.='</div>'; // -- end items
      $fout.='</div>';
      $fout.='</div>';



    }













    // -- display list start

    if($margs['display_type']=='list'){


//		    print_rr($margs);
//		    print_rr($its);




      $fout.='<div class="list-table">';






      $fout.='<div class="items ">';
      $fields_arr = explode(',',$margs['table_fields']);




      // -- still list


      if($margs['parent_filter']){

        $parent_term = get_term_by('slug',$margs['parent_filter'], $this->name_port_item_tag);

//	            print_rr($parent_term);





        if($parent_term){

          $fout.='<h4 class="list-heading">';
          $fout.='<span class="the-label">';
          $fout.=$parent_term->name;

          $fout.='</span>';
          $fout.=' <span class="the-sidenote">( ';
          $fout.=$parent_term->count.' ';
          $fout.=esc_html__("articles",'dzsdtf');
          $fout.=')</span>';
          $fout.='</h4>';
        }


      }





      foreach ($its as $it){

        $fout.='<div class="list-item">';
        $fout.='<a class=" '.$it['permalink_class'].'" href="'.$it['permalink_selected'].'"  '.$it['permalink_extraattr'].'>';
        $fout.=$it['title'];
        $fout.='</a>';
        $fout.='</div>';










        $fout.=$it['item_extra_html'];
      }

      // -- end foreach




      $fout.='</div>'; // -- end items
      $fout.='</div>';



    }























    if($margs['display_type']=='table'){


//		    print_rr($margs);
//		    print_rr($its);



      $fout.='<div class="flex-table">';




      $fields_arr = explode(',',$margs['table_fields']);


      // -- header start
      $fout.='<div class="flex-row flex-row--header">';
      $fout.='<div class="flex-row--inner">';


//	        print_rr($fields_arr);


      foreach ($fields_arr as $fa){
        $fout.='<div class="flex-row-field flex-row-field--'.$fa.'">';

        $lab = '';

        if($fa=='thumb'){

        }
        if($fa=='title'){
          $lab = esc_html__("Title",'dzsdtf');
        }

        if($fa=='content'){
          $lab = esc_html__("Content",'dzsdtf');
        }

        if($fa=='date'){
          $lab = esc_html__("Date",'dzsdtf');
        }


        if(strpos($fa,'tag_')===0){


          $tag_slug = str_replace('tag_','',$fa);




          $parent_term = get_term_by('slug',$tag_slug, $this->name_port_item_tag);

//	                echo 'parent term - '; print_rr($parent_term);

          $lab = $parent_term->name;
        }

        $fout.=$lab;

        $fout.='</div>';
      }
      $fout.='</div>';
      $fout.='</div>';

      // -- header end






      foreach ($its as $it){

        $fout.='<div class="flex-row">';
        $fout.='<div class="flex-row--inner">';



        $fout.='<figure class="responsive-opener">'.'<i class="fa fa-times-circle-o" aria-hidden="true"></i>'.'</figure>';




        foreach ($fields_arr as $fa){
          $fout.='<div class="flex-row-field flex-row-field--'.$fa.'">';

          $lab = '';

//			        print_rr($it);

          if($fa=='thumb'){


            $fout.='<figure class="dzsdtf-thumb divimage"';

            $fout.=' style=" background-image: url(';

            $fout.=$this->get_directory_thumb($it['id']);
//			            print_rr($it);
            $fout.='); "';
            $fout.='>';
            $fout.='</figure>';

          }


          if($fa=='title'){
            $lab = $it['title'];
          }

          if($fa=='content'){
            $lab = $it['content'];
          }


          if($fa=='date'){

//			            print_rr($it);
            $lab = $it['date'];



          }


          if(strpos($fa,'tag_')===0){


            $tag_slug = str_replace('tag_','',$fa);



            $parent_term = get_term_by('slug',$tag_slug, $this->name_port_item_tag);

//				        print_rr($parent_term);

            $term_list = wp_get_post_terms($it['id'], $this->name_port_item_tag, array(
              "fields" => "all",
              "parent" => $parent_term->term_id,
            ));


            foreach ($term_list as $tli){
              if($lab){
                $lab.=',';
              }

              $lab.=$tli->name;
            }

//				        print_rr($term_list);


          }

          $fout.=$lab;

          $fout.='</div>';
        }


















        $fout.='</div>'; // -- end flex row--inner






        // -- responsive
        $fout.='<div class="dzsdtf-responsive-con">';
        foreach ($fields_arr as $fa){


          if($fa=='thumb' || $fa=='title'){
            continue;
          }



          $fout.='<div class="responsive-row-field responsive-flex-row-field--'.$fa.'">';

          $lab = '';
          $contento = '';

//			        print_rr($it);






          if($fa=='content'){
            $lab = esc_html__("Content",'dzsdtf');
            $contento = $it['all_content'];
          }


          if($fa=='date'){

//			            print_rr($it);
            $lab = esc_html__("Date",'dzsdtf');
            $contento = $it['date'];



          }


          if(strpos($fa,'tag_')===0){


            $tag_slug = str_replace('tag_','',$fa);



            $parent_term = get_term_by('slug',$tag_slug, $this->name_port_item_tag);

//				        print_rr($parent_term);

            $term_list = wp_get_post_terms($it['id'], $this->name_port_item_tag, array(
              "fields" => "all",
              "parent" => $parent_term->term_id,
            ));


            foreach ($term_list as $tli){

              $lab = $parent_term->name;
              if($contento){
                $contento.=',';
              }

              $contento.=$tli->name;
            }

//				        print_rr($term_list);


          }


          $fout.='<div class="responsive-row-field--label">';
          $fout.=$lab;
          $fout.='</div>';

          $fout.='<div class="responsive-row-field--content">';

          if($fa=='title'){

            $fout.='<a class=" '.$it['permalink_class'].'" href="'.$it['permalink_selected'].'"  '.$it['permalink_extraattr'].'>';
          }
          $fout.=$contento;
          if($fa=='title'){

            $fout.='</a>';
          }
          $fout.='</div>';

          $fout.='</div>';
        }
        $fout.='</div>';








        $fout.='</div>'; // -- end flex row





        $fout.=$it['item_extra_html'];
      }

      // -- end foreach





      $fout.='</div>';



    }
    if($margs['display_type']=='map'){

      wp_enqueue_script('googleloaded','https://www.google.com/jsapi?key='.$this->db_mainoptions['gmaps_api_key']);


      wp_enqueue_script('dzstooltip',$this->base_url.'libs/dzstooltip/dzstooltip.js');
      wp_enqueue_style('dzstooltip',$this->base_url.'libs/dzstooltip/dzstooltip.css');




      $arr_markers = array();

      foreach ($its as $it){

        $aux = array_merge(array(),$it);


        $aux['content'] = dzs_get_excerpt(-1, array(
          'maxlen' => 50
        , 'striptags' => true
        , 'stripshortcodes' => true
        , 'forceexcerpt' => false //if set to true will ignore the manual post excerpt
        , 'try_to_close_unclosed_tags' => false // -- this will try to close unclosed tags
        , 'readmore' => 'auto'
        , 'readmore_markup' => ' [...]'
        , 'content' => $aux['content']
        ));


        foreach ($arr_tooltip_filters_show as $arri){
//	                echo 'arri - '; print_rr($arri);

          $main_term = get_term_by('slug',$arri['slug'],$this->name_port_item_tag);


//		            echo '$main_term - '; print_rr($main_term);
//	                print_rr($it);

          if($main_term && $it){

            $terms = wp_get_post_terms($it['id'],$this->name_port_item_tag,array(

              'parent'=>$main_term->term_id
            ));

//	                echo 'terms - '; print_rr($terms);

            $aux['content'].='<h6>'.$arri['label']."</h6>";

            if(is_array($terms) && isset($terms[0])){
              $aux['content'].='<p class="filter-content">';

              $aux['content'].=$terms[0]->name;
              $aux['content'].='</p>';
            }
          }



        }

//                print_rr($aux);

        if($aux['lat']){

          array_push($arr_markers, $aux);
        }
      }


      $opts = array(

        'type'=>'display',
        'lat'=>$margs['lat'],
        'long'=>$margs['long'],
        'zoom'=>$margs['zoom'],
        'arr_markers'=>$arr_markers,
      );

      $fout.='<div class="map-canvas" data-options=\''.esc_attr(json_encode($opts)).'\'></div>
';



    }




//		echo 'get_query_var(\'dzsdtf_paged\',1) - '.get_query_var('dzsdtf_paged',1).'|||';

//		print_rr($query);

    if($query->max_num_pages && $query->max_num_pages>1){


      $fout.='<div class="dzs-pagination-con">';
      $fout.= dzs_pagination($query->max_num_pages, 3, array(

        'container_class'=>'dzs-pagination ',
        'include_raquo'=>false,
        'style'=>'div',
        'paged'=>$paged,
        'a_class'=>'pagination-item',
        'wrap_before_text'=>'',
        'wrap_after_text'=>'',
        'link-style'=>'dzsdtf_paged',
      ));
      $fout.='</div>';
    }


    $fout.=$dir_extra_html;

    $fout.='</div><!-- end .directory-form -->';






    wp_enqueue_script('directoryform',$this->base_url.'libs/directoryform/directoryform.js', array('jquery'));
    wp_enqueue_style('directoryform',$this->base_url.'libs/directoryform/directoryform.css');







    return $fout;


  }

  function get_post_meta_all($post_id){
    $myvals = get_post_meta($post_id);

    return $myvals;
  }
  function shortcode_directory_submit($pargs, $content=''){
    $fout = '';

    $margs = array(
      'input_height' => '10',
      'extra_classes' => '',
      'form' => '',
    );


    if(is_array($pargs)){
      $margs = array_merge($margs,$pargs);
    }



//		$temp = get_post(1719);

//		print_rr($temp);

//        print_rr($_POST);



    $fout_form = '';
    $error_messages_str = '';



    $show_form = true;
    $allowed_to_submit = true;




    $user_id = $this->get_current_user_id();

    if($user_id){


      if($this->db_mainoptions['user_class']=='all'){

      }else{
        if(current_user_can('manage_options')||current_user_can('directory_submit_directory_entries')){

        }else{




          if(get_option('dzsdtf_membership_expires_for_'.$user_id) && get_option('dzsdtf_membership_expires_for_'.$user_id)<time()){



          }else{
            $error_messages_str.='<div><span class="dzs-warning dzsdtf-warning">'.esc_html__('Cannot submit - you need to have proper membership.','dzsdtf');


            $show_form = false;

          }

        }
      }



    }else{

      $error_messages_str.='<div><span class="dzs-warning dzsdtf-warning">'.esc_html__('Cannot submit - you need to be logged in.','dzsdtf');


      $error_messages_str.='</span></div>';


      $show_form = false;


    }

    if(defined("DZSDTF_IS_PREVIEW") && DZSDTF_IS_PREVIEW=='ON'){
      $show_form = true;
      $error_messages_str.='<div class="dzs-warning dzsdtf-warning">'.sprintf(esc_html__('This is %sdemo%s mode. Form will be shown for preview purpose.','dzsdtf'),'<strong>','</strong>').'</div>';
    }






    $post_id = $this->sanitize_post_type_slug_to_id($margs['form'],$this->name_frontend_forms);


    $po= get_post($post_id);



    $meta = $this->get_post_meta_all($po->ID);



//		echo 'po - '; print_rr($po);
//		echo 'meta - '; print_rr($meta);



    $input_style = get_post_meta($po->ID,'dzsdtf_meta_input_style',true);

    if($input_style==''){
      $input_style= ' style-sharp';
    }



    $fout_form.='<form class="dzsdtf-frontend-submit  '.$input_style.'" method="post" action="">';


    $fout_form.='<input type="hidden" name="dzsdtf_action" value="submit_entry"/>';
    $fout_form.='<input type="hidden" name="dzsdtf_meta_layout_id" value="'.$post_id.'"/>';
    $fout_form.='<input type="hidden" name="dzsdtf_cat" value="'.get_post_meta($post_id,'dzsdtf_meta_post_category',true).'"/>';


    $cont = $po->post_content;


//		echo '<pre>$cont - '.$cont.'</pre>';
//		if(strpos($cont,'input_type="map"')!==false){
//
//			$fout_form.='<input type="hidden" name="lat" value=""/>';
//			$fout_form.='<input type="hidden" name="long" value="/>';
//        }

//		preg_match_all("/\[dzspgb_element type_element=\"map\".*?lat=\"(.*?)\".*?long=\"(.*?)\".*?\[\/dzs/", $input_lines, $output_array);




    // -- applying input style class
//		$cont = str_replace('[dzspgb_element input_type="input"','[dzspgb_element input_type="input" input-style="input-'.$input_style.'"',$cont);
//		$cont = str_replace('[dzspgb_element input_type="textarea"','[dzspgb_element input_type="textarea" input-style="input-'.$input_style.'"',$cont);
    $cont = str_replace('[dzspgb_element type_element="input"','[dzspgb_element type_element="input" input-style="input-'.$input_style.'"',$cont);
    $cont = str_replace('[dzspgb_element type_element="select"','[dzspgb_element type_element="select" input-style="input-'.$input_style.'"',$cont);
    $cont = str_replace('[dzspgb_element type_element="upload"','[dzspgb_element type_element="upload" input-style="input-'.$input_style.'"',$cont);




//		echo '<pre>$cont -> '.$cont.'</pre>';

//		print_rr($cont);


    $fout_form.=do_shortcode($cont);

    $fout_form.='</form>';



    if($error_messages_str){
      $fout.=$error_messages_str;
    }
    if($show_form){
      $fout.=$fout_form;
    }


    wp_enqueue_script('directoryform',$this->base_url.'libs/directoryform/directoryform.js');
    wp_enqueue_style('directoryform',$this->base_url.'libs/directoryform/directoryform.css');



    return $fout;


  }

  function import_demo_create_portfolio_item($pargs = array()) {


    // -- really insert post




    $margs = array(

      'post_title'=>'',
      'post_content'=>'',
      'post_status'=>'',
      'published_date'=>'',
      'post_type'=>$this->name_port_item,
    );

    $margs = array_merge($margs, $pargs);



    $args = array(
      'post_type' => $margs['post_type'],
      'post_title' => $margs['post_title'],
      'post_content' => $margs['post_content'],
      'post_status'=>$margs['post_status'],



      /*other default parameters you want to set*/
    );


    if(isset($margs['post_name']) && $margs['post_name']){
      $args['post_name'] = $margs['post_name'];
    }

    if(isset($margs['published_date']) && $margs['published_date']){
      $args['post_date'] = $margs['published_date'];
    }


    error_log('actually insert_post - '.print_r($args,true));
    $post_id = wp_insert_post($args);

    return $post_id;


  }
  function import_demo_create_attachment($img_url, $port_id, $img_path){






    $attachment = array(
      'guid'           => $img_url,
      'post_mime_type' => 'image/jpeg',
      'post_title'     => preg_replace( '/\.[^.]+$/', '', basename( $img_url ) ),
      'post_content'   => '',
      'post_status'    => 'inherit'
    );

    // Insert the attachment.
    $attach_id = wp_insert_attachment( $attachment, $img_url, $port_id );


    require_once( ABSPATH . 'wp-admin/includes/image.php' );

    // Generate the metadata for the attachment, and update the database record.
    $attach_data = wp_generate_attachment_metadata( $attach_id, $img_path );
    //        die();
    wp_update_attachment_metadata( $attach_id, $attach_data );

    return $attach_id;
  }



  function sanitize_term_slug_to_id($arg,$taxonomy_name=''){


    if($taxonomy_name==''){
      $taxonomy_name= $this->name_port_item_cat;
    }

    if(is_numeric($arg)){

    }else{

      $term = get_term_by('slug', $arg, $taxonomy_name);

//			echo 'sanitize_term_slug_to_id() - $term - '; print_rr($term);

      if($term){
        $arg = $term->term_id;
      }

    }


    return $arg;
  }

  function import_demo_insert_post_complete($pargs = array()) {






    $margs = array(

      'post_title'=>'',

      'post_content'=>'',
      'post_type'=>$this->name_port_item,
      'post_status'=>'publish',
      'post_name'=>'',
      'img_url'=>'',
      'img_path'=>'',
      'term'=>'',
      'taxonomy'=>'',
      'published_date'=>'', // -- default right now
      'attach_id'=>'',
      'dzsvp_thumb'=>'',
      'dzsvp_item_type'=>'detect',
      'dzsdtf_cat'=>'',


    );

    $margs = array_merge($margs, $pargs);






    if(isset($margs['dzsdtf_meta_content']) && $margs['dzsdtf_meta_content']){
      if($margs['post_content']==''){

        $margs['post_content']=  $margs['dzsdtf_meta_content'];
      }
    }

    if(isset($margs['dzsdtf_meta_published_date']) && $margs['dzsdtf_meta_published_date']){
      if($margs['published_date']==''){

        $margs['published_date']=  $margs['dzsdtf_meta_published_date'];
      }
    }

    if($margs['post_title']==''){
      if(isset($margs['dzsdtf_meta_reason']) && $margs['dzsdtf_meta_reason']){

        $margs['post_title']=  $margs['dzsdtf_meta_reason'];

      }elseif(isset($margs['dzsdtf_meta_subject']) && $margs['dzsdtf_meta_subject']){

        $margs['post_title']=  $margs['dzsdtf_meta_subject'];
      }elseif(isset($margs['dzsdtf_meta_title']) && $margs['dzsdtf_meta_title']){

        $margs['post_title']=  $margs['dzsdtf_meta_title'];
      }else{
        $margs['post_title']=esc_html__("Title placeholder",'dzsdtf');
      }

    }


    $args = array(
      'post_type' => $margs['post_type'],
      'post_title' => $margs['post_title'],

      'post_content' => $margs['post_content'],
      'post_status'=>$margs['post_status'],



      /*other default parameters you want to set*/
    );






    $current_user = wp_get_current_user();
    if ( 0 == $current_user->ID ) {
      $args['post_author']=$current_user->ID;
    } else {
      $args['post_author']='1';
    }


    if($margs['post_name']){
      //            $args['name']=$margs['post_name'];
      $args['post_name']=$margs['post_name'];
    }


    if($margs['term']){

      $term = $margs['term'];
    }else{
      if($margs['dzsdtf_cat']){
        $margs['term'] = $this->sanitize_term_slug_to_id($margs['dzsdtf_cat']);
      }
    }
    $taxonomy = $margs['taxonomy'];

    if($margs['img_url']){

      $img_url = $margs['img_url'];
    }
    $img_path = $margs['img_path'];


    if(isset($margs['published_date']) && $margs['published_date']){
      $args['published_date'] = $margs['published_date'];
    }


    //        print_rr($margs);



    error_log(' item import from post_complete - '.print_rr($margs,true).'||| args -'.print_rr($args,true));
    $port_id = $this->import_demo_create_portfolio_item($args);

    if($margs['term']) {
      $term = $margs['term'];


      if(is_object($margs['term']) && isset($margs['term']['term_id'])){
        $term = $margs['term']['term_id'];
      }
      wp_set_object_terms($port_id, $term, $taxonomy);
    }



//		error_reporting(E_ALL);

//		error_log('whaa');
    foreach ($margs as $lab => $val){
      if(strpos($lab,'dzsdtf_meta_filter')===0){

        $main_term_slug = str_replace('dzsdtf_meta_filter_','',$lab);


        $this_term = null;
        $parent_term = null;
        $taxonomy = $this->name_port_item_tag;

        if($main_term_slug=='all'){


          $this_term = get_term_by('slug', $val, $taxonomy);


          if($this_term->parent){

            $parent_term = get_term_by('id',$this_term->parent, $taxonomy);
          }else{

          }

        }else{

          $parent_term = get_term_by('slug', $main_term_slug, $taxonomy);

        }


        $term = get_term_by('slug', $val, $taxonomy);



        error_log('$taxonomy 2 - '.print_r($taxonomy,true));
        error_log('$parent_term - '.print_r($parent_term,true));
        error_log('$this_term - '.print_r($this_term,true));


        if($parent_term){

          if($this_term){

            wp_set_object_terms($port_id, array(intval($parent_term->term_id),intval($term->term_id)), $taxonomy);
          }else{
            // -- set only main term

            wp_set_object_terms($port_id, array(intval($this_term->term_id)), $taxonomy);
          }

        }else{

          if($this_term) {


            wp_set_object_terms( $port_id, array( intval( $this_term->term_id ) ), $taxonomy );
          }
        }


//
//				error_log('$taxonomy 2 - '.print_r($taxonomy,true));
//				error_log('term 2 - '.print_r($term,true));

      }
      if(strpos($lab,'dzsdtf_meta')===0){

        update_post_meta($port_id,$lab,$val);
      }
    }







    //        update_post_meta($port_id,'q_meta_post_media',$img_url);







    if($margs['attach_id']){

      set_post_thumbnail( $port_id, $margs['attach_id'] );
    }else{

      if($margs['img_url']) {
        $attach_id = $this->import_demo_create_attachment($margs['img_url'], $port_id, $img_path);
        set_post_thumbnail($port_id, $attach_id);

        $this->import_demo_last_attach_id = $attach_id;
      }

    }





    return $port_id;



  }







  function handle_customize_register($wp_customize){










  }



  function shortcode_dzsdtf_row($pargs=array(), $content=''){
    $fout = '';

    $margs = array(
      'input_height' => '10',
      'extra_classes' => '',
      'column_padding' => 'default',
    );


    if(is_array($pargs)){
      $margs = array_merge($margs,$pargs);
    }

    $fout.='<div class="dzsdtf-row dzs-row '.$margs['extra_classes'].'"';


    if($margs['column_padding']){
      $fout.=' data-column_padding="'.$margs['column_padding'].'"';
    }


    $fout.='>';


    $shortcodes = array( 'dzspgb_row_part', 'directory_form' );

    foreach ( $shortcodes as $shortcode ) {

      $array = array (
        '<p>[' . $shortcode => '[' .$shortcode,
        '<p>[/' . $shortcode => '[/' .$shortcode,
        $shortcode . ']</p>' => $shortcode . ']',
        $shortcode . ']<br />' => $shortcode . ']'
      );

      $content = strtr( $content, $array );
    }




    if(isset($_GET['directory_s']) && $_GET['directory_s']){
//	        echo '$content - ';  print_rr($content);

      $content = preg_replace("/part=\".*?\"/", 'part="1.1"', $content);
    }


    $fout.=do_shortcode($content);

    $fout.='</div><!--end .dzsdtf-row-->';



    return $fout;

  }


  function shortcode_dzsdtf_row_part($pargs=array(), $content=''){
    $fout = '';

    $margs = array(
      'input_height' => '10',
      'part' => '1.1',
      'extra_classes' => '',
    );


    if(is_array($pargs)){
      $margs = array_merge($margs,$pargs);
    }

    $fout.='<div class="';


    if($margs['part']=='1.1'){
      $fout.='dzs-col-md-12 ';
    }
    if($margs['part']=='1.2'){
      $fout.='dzs-col-md-6 ';
    }
    if($margs['part']=='1.3'){
      $fout.='dzs-col-md-4 ';
    }

    $fout.=''.$margs['extra_classes'].' dzsdtf-row-part">';

    $fout.=do_shortcode($content);

    $fout.='</div>';



    return $fout;

  }

  function shortcode_dzsdtf_element($pargs=array(), $content=''){
    $fout = '';

    $margs = array(
      'type_element' => '',
      'extra_classes' => '',
    );


    if(is_array($pargs)){
      $margs = array_merge($margs,$pargs);
    }


//        echo '<pre>\'dzspgb_shortcode_\'.$margs[\'type_element\'] - '.'(dzspgb_shortcode_'.$margs['type_element'].')'.'('.function_exists('dzspgb_shortcode_'.$margs['type_element']).')</pre>';
    if(function_exists('dzspgb_shortcode_'.$margs['type_element'])){





      $dzsdtf_extra_meta_options = get_option('dzsdtf_extra_meta_options');

      if(is_array($dzsdtf_extra_meta_options)==false){
        $dzsdtf_extra_meta_options = array();
      }


//	        echo '$dzsdtf_extra_meta_options - '; print_rr($dzsdtf_extra_meta_options);

//	        print_r('shortcode_dzsdtf_element - '.print_rr($margs,true).'('.$content.')');


      $sw_not_found = false;

      foreach ($dzsdtf_extra_meta_options as $lab=>$meta_option){

        if(isset($margs['input_name'])){

          if($lab===$margs['input_name']){
            $sw_not_found = true;
          }
        }
      }


      if($sw_not_found==false){

//	            echo '$sw_not_found - ('.$sw_not_found.')<br>';
//	            print_r('shortcode_dzsdtf_element - '.print_rr($margs,true).'('.$content.')');
//
//	            echo 'isset($margs[\'input_type\']) - ('.isset($margs['input_type']).')<br>';
//	            echo '($margs[\'input_type\']==\'input\' || $margs[\'input_type\']==\'textarea\') - ('.($margs['input_type']=='input' || $margs['input_type']=='textarea').')<br><br>';
      }
      if(isset($margs['input_type']) &&  ($margs['input_type']=='input' || $margs['input_type']=='textarea') &&  $sw_not_found==false){



        $dzsdtf_extra_meta_options[$margs['input_name']] = $margs['input_label_name'];
//	            echo '$dzsdtf_extra_meta_options - '; print_rr($dzsdtf_extra_meta_options);
        update_option('dzsdtf_extra_meta_options',$dzsdtf_extra_meta_options);
      }







      $lab_func = 'dzspgb_shortcode_'.$margs['type_element'];

      $fout.=$lab_func($margs,$content);
    }



    return $fout;

  }


  function filter_the_content($content){

    $fout = $content;

    echo $fout;



    return $fout;
  }





  public function handle_plugin_activate(){
    $this->plugin_justactivated = "on";

    $this->register_links();
    flush_rewrite_rules();


  }


  function handle_add_meta_boxes(){

    add_meta_box('dzsdtf_meta_options',esc_html__('Directory submit options','dzsdtf'),array($this,'meta_contact_form'),$this->name_frontend_forms,'normal');














    add_meta_box('dzsdtf_meta_options',$this->title_label.' '.esc_html__("Meta Options",'dzsdtf'),array($this,'admin_meta_options'),'page','normal');
    add_meta_box('dzsdtf_meta_options',$this->title_label.' '.esc_html__("Meta Options",'dzsdtf'),array($this,'admin_meta_options'),'post','normal');



    add_meta_box('dzsdtf_meta_options',$this->title_label.' '.esc_html__("Meta Options",'dzsdtf'),array($this,'admin_meta_options'),$this->name_port_item,'normal');
//        add_meta_box('dzsdtf_meta_options_portfolio',$this->title_label.' '.esc_html__("Meta Options",'dzsdtf'). ' '.esc_html__("Portfolio",'dzsdtf'),array($this,'admin_meta_options_portfolio'),$this->name_port_item,'normal');








  }














  function admin_meta_options(){
    global $post, $wp_version;
    $struct_uploader = '<div class="dzs-wordpress-uploader">
<a href="#" class="button-secondary">' . esc_html__("Upload",'dzsdtf') . '</a>
</div>';

    ?>
      <div class="dzsdtf_meta-meta-bigcon con-type-receiver">

          <input type="hidden" name="dzsdtf_meta_nonce" value="<?php echo wp_create_nonce('dzsdtf_meta_nonce'); ?>"/>






        <?php








        $dzsdtf_extra_meta_options = get_option('dzsdtf_extra_meta_options');

        if(is_array($dzsdtf_extra_meta_options)==false){
          $dzsdtf_extra_meta_options = array();
        }







        foreach ($dzsdtf_extra_meta_options as $lab=>$label){


          $complete_lab = $lab;
          if(strpos($lab,'dzsdtf_meta')===false){

            $complete_lab = 'dzsdtf_meta_'.$lab;
          }

          if($complete_lab=='dzsdtf_meta_content'){
            continue;
          }

          // -- val - slug ||| lab - name

          echo '            <div class="setting type-all setting-background-image">
                <h4>'.esc_html__($label,'dzsdtf').'</h4>
                '.DZSHelpers::generate_input_text($complete_lab, array(
              'class'=>'',
              'seekval'=>get_post_meta($post->ID, $complete_lab, true),
            ))
            .'
            </div>';

        }







        $lab = 'dzsdtf_meta_bg_image';
        ?>
          <div class="setting type-all setting-background-image">
              <h4><?php echo esc_html__("Background Image",'dzsdtf'); ?></h4>
            <?php echo DZSHelpers::generate_input_text($lab, array(
              'class'=>'',
              'seekval'=>get_post_meta($post->ID, $lab, true),
            ))
            ?>
              <button class="button-secondary dzsq-dzs-wordpress-uploader"><?php echo esc_html__("Upload",'dzsdtf'); ?></button>
              <p class="sidenote"><?php echo esc_html__("set a background image",'dzsdtf'); ?></p>
          </div>


        <?php
        $lab = 'dzsdtf_meta_lat';
        ?>
          <div class="setting type-all setting-background-image">
              <h4><?php echo esc_html__("Latitude",'dzsdtf'); ?></h4>
            <?php echo DZSHelpers::generate_input_text($lab, array(
              'class'=>'',
              'seekval'=>get_post_meta($post->ID, $lab, true),
            ))
            ?>

              <p class="sidenote">* <?php echo esc_html__("only for map location",'dzsdtf'); ?></p>
          </div>

        <?php
        $lab = 'dzsdtf_meta_long';
        ?>
          <div class="setting type-all setting-background-image">
              <h4><?php echo esc_html__("Longitude",'dzsdtf'); ?></h4>
            <?php echo DZSHelpers::generate_input_text($lab, array(
              'class'=>'',
              'seekval'=>get_post_meta($post->ID, $lab, true),
            ))
            ?>

              <p class="sidenote">* <?php echo esc_html__("only for map location",'dzsdtf'); ?></p>
          </div>







      </div>

    <?php
  }




  function handle_admin_meta_save($post_id) {

    global $dzsdtf_theme_data;

    if(defined("dzsdtf_VERSION")){


      return dzsdtf_handle_admin_meta_save($post_id);
    }

    global $post;
    if (!$post) {
      return;
    }
    if (isset($post->post_type)) {

    }
    /* -- Check autosave */
    $is_preview = false;
    if(isset($_POST['wp-preview']) && $_POST['wp-preview']=='dopreview'){


      $is_preview = true;

    }





    if (isset($_REQUEST['dzsdtf_meta_nonce'])) {
      $nonce = $_REQUEST['dzsdtf_meta_nonce'];
      if (!wp_verify_nonce($nonce,'dzsdtf_meta_nonce')){
        wp_die('Security check');
      }
    }


    if (is_array($_POST)) {
      $auxa = $_POST;
      foreach ($auxa as $label => $value) {


        $label_to_save = $label;

        if($is_preview){
          $label_to_save.='_preview';
        }




        if (strpos($label,'dzsdtf_meta_') !== false) {
          update_post_meta($post->ID,$label_to_save,$value);
        }

        if (strpos($label,'dzsdtf_meta_') !== false) {
          DZSHelpers::wp_savemeta($post->ID,$label,$value);
        }
      }
    }




  }


  function handle_edit_form_after_title(){


    // -- before the wp editor


    global $post;



    if($post && $post->post_type==$this->name_frontend_forms) {


      global $dzspgb_templates;
      include_once "pagebuilder/class-dzspgb.php";


      $aux_revs = (wp_get_post_revisions($post->ID));


      if (count($aux_revs) == 0 && $post->post_content == '') {

        wp_enqueue_style('tabs.and.accordions', $this->base_url.'libs/dzstabsandaccordions/dzstabsandaccordions.css');
        wp_enqueue_script('tabs.and.accordions', $this->base_url.'libs/dzstabsandaccordions/dzstabsandaccordions.js');


        if(defined('dzsdtf_VERSION')){

        }




        ?>
          <h4 class="import-form-con--label" style="text-align: center"><?php echo esc_html__("Quick Start"); ?></h4>
          <div class="import-form-con">
              <div class="import-form--head">

                  <div class="option option-blank  active">

                      <div class="the-icon">
                          <svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" width="40px" height="40px" viewBox="0 0 129.688 132.627" enable-background="new 0 0 129.688 132.627" xml:space="preserve"> <g> <g> <g> <g> <path fill="#5A5B5D" d="M114.977,126.947H14.711c-5.79,0-10.5-4.71-10.5-10.5V16.181c0-5.79,4.71-10.5,10.5-10.5h78.533 c0.663,0,1.299,0.263,1.768,0.732l29.732,29.733c0.469,0.469,0.732,1.104,0.732,1.768v78.533 C125.477,122.237,120.767,126.947,114.977,126.947z M14.711,10.681c-3.033,0-5.5,2.467-5.5,5.5v100.267 c0,3.032,2.467,5.5,5.5,5.5h100.266c3.033,0,5.5-2.468,5.5-5.5V38.95L92.209,10.681H14.711z"/> </g> </g> <g> <g> <path fill="#5A5B5D" d="M122.977,40.414h-21.732c-5.79,0-10.5-4.71-10.5-10.5V8.181c0-1.011,0.609-1.923,1.543-2.31 c0.933-0.387,2.01-0.174,2.724,0.542l29.732,29.733c0.715,0.715,0.929,1.79,0.542,2.724 C124.9,39.805,123.988,40.414,122.977,40.414z M95.745,14.216v15.698c0,3.033,2.467,5.5,5.5,5.5h15.697L95.745,14.216z"/> </g> </g> </g> </g> </svg>
                      </div>
                      <h4><?php echo esc_html__("BLANK FORM"); ?></h4>
                  </div>

                  <div class="option option-template">

                      <div class="the-icon">
                          <svg version="1.1"  xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
                               width="40px" height="40px" viewBox="0 0 129.688 132.627" enable-background="new 0 0 129.688 132.627"
                               xml:space="preserve">
<g>
    <g>
        <g>
            <g>
                <path fill="#5A5B5D" d="M114.977,126.947H14.711c-5.79,0-10.5-4.71-10.5-10.5V16.181c0-5.79,4.71-10.5,10.5-10.5h78.533
					c0.663,0,1.299,0.263,1.768,0.732l29.732,29.733c0.469,0.469,0.732,1.104,0.732,1.768v78.533
					C125.477,122.237,120.767,126.947,114.977,126.947z M14.711,10.681c-3.033,0-5.5,2.467-5.5,5.5v100.267
					c0,3.032,2.467,5.5,5.5,5.5h100.266c3.033,0,5.5-2.468,5.5-5.5V38.95L92.209,10.681H14.711z"/>
            </g>
        </g>
        <g>
            <g>
                <path fill="#5A5B5D" d="M122.977,40.414h-21.732c-5.79,0-10.5-4.71-10.5-10.5V8.181c0-1.011,0.609-1.923,1.543-2.31
					c0.933-0.387,2.01-0.174,2.724,0.542l29.732,29.733c0.715,0.715,0.929,1.79,0.542,2.724
					C124.9,39.805,123.988,40.414,122.977,40.414z M95.745,14.216v15.698c0,3.033,2.467,5.5,5.5,5.5h15.697L95.745,14.216z"/>
            </g>
        </g>
    </g>
</g>
                              <rect x="25.344" y="51.914" fill="#5A5B5D" width="79" height="6.586"/>
                              <rect x="25.344" y="71.914" fill="#5A5B5D" width="79" height="6.586"/>
                              <rect x="25.344" y="89.914" fill="#5A5B5D" width="79" height="6.586"/>
</svg>
                      </div>
                      <h4><?php echo esc_html__("TEMPLATE FORM"); ?></h4>
                  </div>
              </div>

              <!-- end head -->

              <div class="import-form--body animating">
                  <div class="option option-body-template"></div>

                  <div class="option option-body-template">
                      <div class="options-con">

                          <a class="template-option" onclick="document.getElementById('tabs-opts').api_goto_tab(0); return false;" href="#"><?php echo esc_html__("Submit for list",'dzsdtf'); ?></a>
                          <a class="template-option" onclick="document.getElementById('tabs-opts').api_goto_tab(1); return false;" href="#"><?php echo esc_html__("Map submit",'dzsdtf'); ?></a>
                          <a class="template-option" onclick="document.getElementById('tabs-opts').api_goto_tab(2); return false;" href="#"><?php echo esc_html__("Shop listing",'dzsdtf'); ?></a>
                      </div>
                      <div class="tabs-con">
                          <div id="tabs-opts" class="dzsdtf-tabs dzs-tabs debug-target auto-init skin-melbourne" data-options='{ "design_tabsposition" : "none"
,"design_transition": "slide"
,"design_tabswidth" : "default"
,"toggle_breakpoint" : "200"
,"settings_appendWholeContent":true
,"refresh_tab_height": "1000"
,"toggle_type": "accordion"}'
                          >

                              <div class="dzs-tab-tobe">
                                  <div class="tab-menu with-tooltip">
                                  </div>
                                  <div class="tab-content">
                                      <img class="fullwidth import-dzsdtf-sample import-dzsdtf-sample-1" src="<?php echo $this->base_url; ?>assets/sample_data/directory-list.jpg"/>

                                  </div>
                              </div>

                              <div class="dzs-tab-tobe">
                                  <div class="tab-menu with-tooltip">
                                  </div>
                                  <div class="tab-content">
                                      <img class="fullwidth import-dzsdtf-sample import-dzsdtf-sample-2" src="<?php echo $this->base_url; ?>assets/sample_data/directory-map.jpg"/>

                                  </div>
                              </div>

                              <div class="dzs-tab-tobe">
                                  <div class="tab-menu with-tooltip">
                                  </div>
                                  <div class="tab-content">
                                      <img class="fullwidth import-dzsdtf-sample import-dzsdtf-sample-3" src="<?php echo $this->base_url; ?>assets/sample_data/directory-shop.jpg"/>

                                  </div>
                              </div>




                          </div>
                      </div>

                  </div>
              </div>
          </div>

        <?php
      }
    }
  }

  function meta_contact_form(){
    global $post, $wp_version;
    ?>
      <div class="dzsdtf_meta-meta-bigcon con-type-receiver">

          <input type="hidden" name="dzsdtf_meta_nonce" value="<?php echo wp_create_nonce('dzsdtf_meta_nonce'); ?>"/>

        <?php
        $lab = 'dzsdtf_meta_input_style';

        $arr_opts = array(
          array(
            'value'=>'style-theme',
            'label'=>esc_html__('Theme style'),
          ),
          array(
            'value'=>'style-cosco',
            'label'=>esc_html__('Rounded style'),
          ),
          array(
            'value'=>'style-sharp',
            'label'=>esc_html__('Sharp style'),
          ),
        )

        ?>
          <div class="setting type-all">
              <h4><?php echo esc_html__("Forms Style"); ?></h4>
            <?php echo DZSHelpers::generate_select($lab, array(
              'class'=>'dzs-style-me skin-beige',
              'options'=>$arr_opts,
              'seekval'=>get_post_meta($post->ID, $lab, true),
            ))
            ?>
              <p class="sidenote"><?php echo esc_html__("set a custom markup - choose Theme Style to leave style unchanged"); ?></p>
          </div>

        <?php
        $lab = 'dzsdtf_meta_post_category';

        $arr_opts = array(
          array(
            'value'=>'',
            'label'=>esc_html__('Uncategorized'),
          ),
        );

        $terms = get_terms( $this->name_port_item_cat, array(
          'hide_empty' => false,
        ) );


        foreach ($terms as $tm){

          $aux = array(
            'label'=>$tm->name,
            'value'=>$tm->slug,
          );

          array_push($arr_opts, $aux);
        }






        ?>
          <div class="setting type-all">
              <h4><?php echo esc_html__("Submit into"); ?></h4>
            <?php echo DZSHelpers::generate_select($lab, array(
              'class'=>'dzs-style-me skin-beige',
              'options'=>$arr_opts,
              'seekval'=>get_post_meta($post->ID, $lab, true),
            ))
            ?>
              <p class="sidenote"><?php echo esc_html__("select in which category to submit - this is for the admin - to choose which table he shows",'dzsdtf'); ?></p>
          </div>

        <?php




        ?>

        <?php
        $lab = 'dzsdtf_meta_custom_markup';
        ?>
          <div class="setting type-all">
              <h4><?php echo esc_html__("Custom Markup"); ?></h4>
            <?php echo DZSHelpers::generate_input_textarea($lab, array(
              'class'=>'',
              'seekval'=>get_post_meta($post->ID, $lab, true),
            ))
            ?>
              <p class="sidenote"><?php echo esc_html__("set a custom markup",'dzsdtf'); ?></p>
          </div>


      </div>

      <div class="code"><?php echo esc_html__("shortcode you can use for displaying: ",'dzsdtf'); ?><pre>[directory_submit form="<?php
          echo $post->post_name;
          ?>"]</pre></div>
    <?php


  }

  public function handle_plugin_deactivate(){

    flush_rewrite_rules();

  }






  function register_links(){





    $labels = array(
      'name' => esc_html__("Directory entries"),
      'singular_name' => esc_html__('Directory entry'),
    );


    $args = array(
      'labels' => $labels,
      'public' => true,
      'has_archive' => true,
      'hierarchical' => false,
      'supports' => array('title','editor','author','thumbnail','post-thumbnail','comments','excerpt','revisions', 'custom-fields'),
      'rewrite' => array('slug' => 'directory-entry'),
      'yarpp_support' => true,

    );
    register_post_type($this->name_port_item,$args);



    // -- categories for admin / form submit
    register_taxonomy(
      $this->name_port_item_cat,$this->name_port_item,array(
        'label' => esc_html__('Directory categories','antfarm'),
        'query_var' => true,
        'show_ui' => true,
        'hierarchical' => true,
      )
    );



    // -- categories for users / front end submit
    register_taxonomy(
      $this->name_port_item_tag,$this->name_port_item,array(
        'label' => esc_html__('Directory filters','antfarm'),
        'query_var' => true,
        'show_ui' => true,
        'hierarchical' => true,
      )
    );











    $labels = array(
      'name' => esc_html__("Submit forms"),
      'singular_name' => esc_html__('Submit form'),
    );






    $args = array(
      'labels' => $labels,
      'public' => true,
      'has_archive' => true,
      'hierarchical' => false,
      'show_in_nav_menus' => false,
      'supports' => array('title','editor','author','thumbnail','post-thumbnail','comments','excerpt','revisions'),
      'rewrite' => array('slug' => 'frontend-form'),
      'yarpp_support' => true,

    );
    register_post_type($this->name_frontend_forms,$args);

    add_filter('user_can_richedit', array($this, 'disable_wyswyg_for_custom_post_type'));






  }
  function disable_wyswyg_for_custom_post_type( $default ){
    global $post;
    if( $post && $post->post_type === $this->name_frontend_forms) return false;
    return $default;
  }


  function handle_init(){




    if(is_admin()){
      if (current_user_can('edit_posts') || current_user_can('edit_pages')) {


        wp_enqueue_script('jquery-ui-core');
        wp_enqueue_script('jquery-ui-sortable');
        wp_enqueue_script('jquery-ui-droppable');


        wp_enqueue_script('dzs.selector',$this->base_url.'libs/dzsselector/dzsselector.js',array('jquery'));
        wp_enqueue_style('dzs.selector',$this->base_url.'libs/dzsselector/dzsselector.css');



        wp_enqueue_style('fontawesome', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css');
        wp_enqueue_style('faiconselector', $this->base_url . 'libs/dzsiconselector/dzsiconselector.css');
        wp_enqueue_script('faiconselector', $this->base_url . 'libs/dzsiconselector/dzsiconselector.js');


        wp_enqueue_script('dzsdtf.admin.global', $this->base_url . 'admin/admin.js');
        wp_enqueue_style('dzsdtf.admin.global', $this->base_url . 'admin/admin.css');



        wp_enqueue_script('toggle',$this->base_url.'assets/dzstoggle/dzstoggle.js');
        wp_enqueue_style('toggle',$this->base_url.'assets/dzstoggle/dzstoggle.css');



        if(isset($_GET['dzsdtf_shortcode_generator_button']) && $_GET['dzsdtf_shortcode_generator_button']=='on'){

          wp_enqueue_style('remove_wp_dashboard_frames', $this->base_url . 'admin/remove_wp_dashboard_frames.css');
          wp_enqueue_style('dzsdtf-styles', $this->base_url . 'assets/dzsdtf_styles/dzsdtf_styles.css');
          wp_enqueue_script('dzsdtf_sg', $this->base_url . 'admin/shortcode_generator.js');

        }else{

        }


        if(isset($_GET['dzsdtf_shortcode_generator_divider']) && $_GET['dzsdtf_shortcode_generator_divider']=='on'){

          wp_enqueue_style('remove_wp_dashboard_frames', $this->base_url . 'admin/remove_wp_dashboard_frames.css');
          wp_enqueue_style('dzsdtf-styles', $this->base_url . 'assets/dzsdtf_styles/dzsdtf_styles.css');
          wp_enqueue_script('dzsdtf_sg', $this->base_url . 'admin/shortcode_generator.js');


        }else{

        }



        if(current_user_can('manage_options') || current_user_can('directory_make_shortcode')){

          wp_enqueue_script('dzsdtf-add-generators', $this->base_url . 'shortcodegenerator/add-generators-to-mce.js');
          wp_enqueue_script('dzsdtf-shortcode-receiver', $this->base_url . 'shortcodegenerator/shortcode-receiver.js');


          wp_enqueue_script('ultibox',$this->base_url.'libs/ultibox/ultibox.js');
          wp_enqueue_style('ultibox',$this->base_url.'libs/ultibox/ultibox.css');

        }
      }









    }else{
      wp_enqueue_script('jquery');


//	        if (session_status() == PHP_SESSION_NONE) {
//		        session_start();
//	        }



    }
    add_image_size( 'dzsdtf-grid-size', 400, 400, array('center','center') ); //300 pixels wide (and unlimited height)



    register_post_status( 'not-for-eyes', array(
      'public'                    => true,
      'exclude_from_search'       => true,
//		    'exclude_from_search'       => false,
//		    'show_in_admin_all_list'    => true,
      'show_in_admin_all_list'    => true,
      'show_in_admin_status_list' => true,
      'label'               => esc_html( 'Directory membership'.'dzsdtf'),
      'label_count'               => _n_noop( 'Directory membership <span class="count">(%s)</span>', 'Directory memberships <span class="count">(%s)</span>' ),
    ) );

    $this->register_links();




    if(function_exists('vc_add_shortcode_param')){

      vc_add_shortcode_param('dzsdtf_add_media', array($this,'vc_dzsdtf_add_media') );
      vc_add_shortcode_param('dzsdtf_add_media_att', array($this,'vc_dzsdtf_add_media_att') );
      vc_add_shortcode_param('dzsqcr_faiconselector', 'vc_dzsqcr_faiconselector' );
      vc_add_shortcode_param('dzsdtf_multiple_checkbox', 'vc_dzsdtf_multiple_checkbox' );
      vc_add_shortcode_param('dzsdtf_icon_selector', 'vc_dzsdtf_icon_selector' );
      vc_add_shortcode_param('dzsdtf_layout_chooser', 'vc_dzsdtf_layout_chooser' );
      vc_add_shortcode_param('dzsdtf_button_customizer', 'vc_dzsdtf_button_customizer' );


    }





    add_action('admin_footer-edit.php',array($this,'status_into_inline_edit'));
    add_action( 'post_submitbox_misc_actions',array($this, 'add_to_post_status_dropdown') );



  }


  function add_to_post_status_dropdown(){
    global $post;
    ?>
      <script>
        jQuery(document).ready(function($){
          $("select#post_status").append("<option value=\"not-for-eyes\" <?php selected('not-for-eyes', $post->post_status); ?>><?php echo esc_html__("Directory membership",'dzsdtf'); ?></option>");
        });
      </script>
    <?php
  }


  function status_into_inline_edit() { // ultra-simple example
    echo "<script>
	jQuery(document).ready( function() {
		jQuery( 'select[name=\"_status\"]' ).append( '<option value=\"not-for-eyes\">".esc_html__("Directory membership",'dzsdtf')."</option>' );
	});
	</script>";
  }



  function handle_init_end(){

    if(is_admin()){

      include_once('admin/dzs_term_reorder.php');

      $dzs_term_reorder = new Dzs_Term_Reorder(array('post',$this->name_port_item), array($this->name_port_item=>array(
        $this->name_port_item_tag
      )),array($this->name_port_item_tag), $this->base_url.'admin/');
    }



    if (isset($_GET['dzsdtf_action']) && $_GET['dzsdtf_action'] == 'upload_image') {


      $upload_dir_arr = wp_get_upload_dir();


      if (session_status() == PHP_SESSION_NONE) {
        session_start();
      }


      $lab_nonce = 'dzsdtf_upload_nonce';
      $nonce = $_REQUEST[$lab_nonce];
      wp_verify_nonce( $nonce, $lab_nonce );
//		    error_log('wp_verify_nonce( $nonce, $lab_nonce ) - '.wp_verify_nonce( $nonce, $lab_nonce ));
      error_log(print_r($upload_dir_arr,true));



      if(wp_verify_nonce( $nonce, $lab_nonce )){


        $basedir = $upload_dir_arr['basedir'];


        $datenow = date('m_y');


        $upload_dir = $basedir.'/dzsdtf_images/'.$datenow;

//			    mkdir('path/to/directory', 0755, true);
        if(file_exists($upload_dir)){

        }else{
          mkdir($upload_dir,0755,true);

        }

        $allowed_filetypes = array('.jpg','.jpeg','.png','.gif','.tiff','.txt','.mp4','.m4v','.ogg','.ogv','.webm','.sql','.mp3');




        if (isset($_FILES['file_field']['tmp_name'])) {
          $cach = $_FILES['file_field'];
          $file_name = $cach['name'];
          $file_name = str_replace(" ", "_", $file_name); // strip spaces
          $path = $upload_dir . "/" . $file_name;


          $original_file_name = $file_name;


          $sw = true;


          foreach ($allowed_filetypes as $dft) {
//            print_r($dft);
            $pos = strpos(strtolower($file_name), $dft);


//            error_log($pos);
            if ($pos > strlen($file_name)-6) {
              $sw = false;
            }
          }

//    print_r($_FILES);

          $target = $upload_dir . "/" . $file_name;

























          if ($sw == true) {


            $arr_report = array(
              'report'=>'error',
              'target'=>$target,
              'text'=>'invalid extension - disallowed_filetype',
            );

            die(json_encode($arr_report));


          }

          if (!is_writable($upload_dir)) {


            $arr_report = array(
              'report'=>'error',
              'target'=>$target,
              'text'=>'dir not writable - check permissions',
            );

            die(json_encode($arr_report));




          }



          $auxindex = 0;
          $auxname = $file_name;
          $auxpath = $target;
          if(file_exists($target)){

//            die('<div class="error">file already exists</div>');

            $part1_target = $target;
            $part2_target = '';



            $part1_name = $auxname;
            $part2_name = '';

            if(strpos($target, '.png')!==false || strpos($target, '.jpg')!==false || strpos($target, '.mp4')!==false || strpos($target, '.m4v')!==false
              || strpos($target, '.ogg')!==false || strpos($target, '.ogv')!==false || strpos($target, '.gif')!==false || strpos($target, '.mp3')!==false
              || strpos($target, '.gif')!==false){
              $part1_target = substr($target, 0, -4);
              $part2_target = substr($target, -4);
            }


            if(strpos($auxname, '.png')!==false || strpos($auxname, '.jpg')!==false || strpos($auxname, '.mp4')!==false || strpos($auxname, '.m4v')!==false
              || strpos($auxname, '.ogg')!==false || strpos($auxname, '.ogv')!==false || strpos($auxname, '.gif')!==false || strpos($auxname, '.mp3')!==false
              || strpos($auxname, '.gif')!==false){
              $part1_name = substr($auxname, 0, -4);
              $part2_name = substr($auxname, -4);
            }

            if(strpos($target, '.jpeg')!==false){
              $part1_target = substr($target, 0, -5);
              $part2_target = substr($target, -5);
            }


            if(strpos($auxname, '.jpeg')!==false){
              $part1_name = substr($auxname, 0, -5);
              $part2_name = substr($auxname, -5);
            }

            while(file_exists($auxpath)===true){
              $auxindex++;

              $auxpath = $part1_target.'_'.$auxindex.$part2_target;
              $auxname = $part1_name.'_'.$auxindex.$part2_name;
            }
          }

          $target = $auxpath;









          $rel_url = $upload_dir.'/'.$auxname;

          error_log('rel_url - '.$rel_url);
//				    $rel_url = str_replace(dirname(__FILE__).'/','',$rel_url);
          $rel_url = str_replace(dirname($upload_dir_arr['basedir']),$upload_dir_arr['baseurl'].'/',$rel_url);
          error_log('rel_url 2- '.$rel_url);
          $rel_url = str_replace('uploads/uploads','uploads/',$rel_url);
          $rel_url = str_replace('uploads//uploads','uploads/',$rel_url);
          $rel_url = str_replace('uploads//','uploads/',$rel_url);
          error_log('rel_url 3- '.$rel_url);






          if (copy($cach['tmp_name'], $target)) {



            $arr_report = array(
              'report'=>'success',
              'target'=>$target,

              'filename'=>$auxname,
              'rel_url'=>$rel_url,
            );

            die(json_encode($arr_report));


          } else {
            $arr_report = array(
              'report'=>'error',
              'target'=>$target,
              'text'=>'file could not be uploaded',
            );

            die(json_encode($arr_report));

          }


        }















      }else{

        $arr_report = array(
          'report'=>'error',
          'target'=>'',
          'text'=>'nonce not correct',
        );

        die(json_encode($arr_report));
      }






    }




    // -- submit directory entry
    if(isset($_POST['dzsdtf_action'])){
      if($_POST['dzsdtf_action']=='submit_entry'){
//		        print_rr($_POST);




        $name = '';

        $email = '';



        $current_user = wp_get_current_user();
        if ( 0 == $current_user->ID ) {

        } else {

          // -- we just set name and email if not logged in



          foreach ($_POST as $lab=>$val){
            $_POST[$lab] = wp_kses($_POST[$lab],$this->allowed_tags);
          }


          $args = array_merge(array(
            'taxonomy'=>$this->name_port_item_cat
          ),$_POST);









          if(defined("DZSDTF_IS_PREVIEW") && DZSDTF_IS_PREVIEW=='ON'){
            echo ' '.sprintf(esc_html__('This is %sdemo%s mode. Form will not be submitted.','dzsdtf'),'<strong>','</strong>');
          }else{

            $new_pid = $this->import_demo_insert_post_complete($args);

//			    wp_reset_postdata();





            // TODO: here is redirect
            wp_redirect(add_query_arg(array(
              'data-submitted'=>'on',
              'new_pid'=>$new_pid,
            ),dzs_curr_url()));
            exit;
          }



        }







//			    exit;
      }
    }



    if( !(get_option('dzsdtf_sample_data_installed')) ){


      // -- here we input sample data


      include_once "class_parts/import_sample_data.php";



//		    update_option('dzsdtf_sample_data_installed','on');

//	        echo ' $file_cont - '.$file_cont;
//	        echo ' $sw_import - '.$sw_import;
    }




    // -- END handle_init_end

  }


  function handle_wp_head(){


//        echo 'ceva';

    if ($this->db_mainoptions['extra_css']) {
      echo '<style class="style-from-dzsdtf">';
      echo $this->db_mainoptions['extra_css'];
      echo '</style>';
    }


    $fout = '<script>';

    $fout.='window.dzsdtf_settings = { version:"'.DZSDTF_VERSION.'"';
    $fout.=',gmaps_api_key: "'.$this->db_mainoptions['gmaps_api_key'].'"';
    $current_user = wp_get_current_user();
    if ( 0 == $current_user->ID ) {
      $fout.=',logged_in:"off"';
    } else {
      $fout.=',logged_in:"on"';
    }
    $fout.='}; ';




//	    $rand = rand(0,100000);


//	    $_SESSION['dzsdtf_upload_nonce'] = $rand;


    $nonce = wp_create_nonce( 'dzsdtf_upload_nonce' );
    $fout.= 'window.dzs_phpfile_path = "'.site_url().'/index.php?dzsdtf_action=upload_image&dzsdtf_upload_nonce='.$nonce.'"; ';

    $fout.='window.ultibox_options_init = {
            \'settings_deeplinking\' : \'on\'
            ,\'nav_mode\' : \'none\'
            ,\'extra_classes\' : \'close-btn-inset\'
            ,\'offset_v\' : 0
        };';


    if($this->db_mainoptions['gmaps_style']){

      $fout.=' window.dzsdtf_gmaps_style = '.$this->db_mainoptions['gmaps_style'];
    }

    $fout .= '</script>';

    global $post;

    if($post && $post->post_type==$this->name_frontend_forms){
    }

    echo $fout;


    wp_enqueue_style('dzsdtf-styles',$this->base_url.'assets/dzsdtf_styles/dzsdtf_styles.css');
  }
  function handle_admin_init(){



    global $dzspgb_templates;

    $post = null;


    if(isset($_GET['post']) && $_GET['post']) {
      $post = get_post($_GET['post']);
    }








    if($post && $post->post_type==$this->name_frontend_forms){

      wp_enqueue_script('tiny_mce','',array('jquery'));
    }





    if( ($post && $post->post_type==$this->name_frontend_forms) || (isset($_GET['action']) && $_GET['action']==='dzspgb_print_templates')  ){

    }


    wp_enqueue_style('dzsdtf-styles',$this->base_url.'assets/dzsdtf_styles/dzsdtf_styles.css');


    if(isset($_GET['action']) && $_GET['action']==='dzspgb_print_templates'){





      $fout = '';



      $fout .= 'var dzspgb_templates = {';


      $ij =0 ;

      foreach($dzspgb_templates as $temp){
        if($ij>0){
          $fout.=',';
        }

        $fout.= $temp['id'];

        $fout.=':';

        $fout.='"';


        $aux = call_user_func($temp['admin_str_function'],array(
          'txt_choose'=>esc_html__('Edit'),
          'type_pb'=>"Row",
        ));


        $lb = array("\r\n","\n","\r");
        $aux = str_replace($lb,'',$aux);

        $aux = str_replace('"',"'q'",$aux);

        $fout.=$aux;

        $fout.='"';

        $ij++;

      }

      $fout .= '}';


      echo $fout;


      die();
    }





    if (isset($_GET['dzsdtf_shortcode_generator']) && $_GET['dzsdtf_shortcode_generator'] == 'on') {
//            dzsdtf_shortcode_builder();

      include_once(dirname(__FILE__) . '/shortcodegenerator/generator.php');
      define('DONOTCACHEPAGE', true);
      define('DONOTMINIFY', true);

    }

  }

  function handle_admin_head(){




    global $post;



    echo '<script>window.dzsdtf_settings = { base_url: "'.$this->base_url.'",version: "'.DZSDTF_VERSION.'",site_url : "'.site_url().'",translate_add_shortcode_button: "'.esc_html__("Add Button").'",translate_add_shortcode_divider: "'.esc_html__("Add Divider").'",translate_add_shortcode: "'.esc_html__("Add directory display").'",translate_background_image: "'.esc_html__("Background Image").'"';



    ?>,shortcode_generator_url: "<?php echo admin_url('admin.php?page='.$this->adminpagename_mainoptions); ?>&dzsdtf_shortcode_generator=on"<?php

    if($post){
      echo ',post_type:"'.$post->post_type.'"';
    }

    echo ',shortcode_generator_button_url: "'.admin_url('admin.php?page='.$this->adminpagename_mainoptions) . '&dzsdtf_shortcode_generator_button=on'.'"';
    echo ',shortcode_generator_divider_url: "'.admin_url('admin.php?page='.$this->adminpagename_mainoptions) . '&dzsdtf_shortcode_generator_divider=on'.'"';


    echo ',shortcode_showcase_generator_url: "'.admin_url('admin.php?page='.$this->adminpagename_mainoptions) . '&dzsdtf_shortcode_showcase_builder=on'.'"};';
    echo '  </script>';







    if($post && $post->post_type==$this->name_frontend_forms){
      global $dzspgb_templates;


      include_once "pagebuilder/class-dzspgb.php";








      $dzspgb_forportal = new DZS_PageBuilder(array(
        'connect_to_db' => false,
        'is_wp'=>true,
      ));









      $struct_dzspgb_section = str_replace(array("\r","\r\n","\n"),'',$dzspgb_forportal->generate_admin_section_part1(array()).$dzspgb_forportal->generate_admin_section_part2(array()));

      $args = array();


      $struct_dzspgb_container = str_replace(array("\r","\r\n","\n"),'',$dzspgb_forportal->generate_admin_container_part1($args).$dzspgb_forportal->generate_admin_container_part2($args));

      $struct_dzspgb_row = str_replace(array("\r","\r\n","\n"),'',$dzspgb_forportal->generate_admin_row_part1(array()).$dzspgb_forportal->generate_admin_row_part2(array()));
      $struct_dzspgb_row = str_replace(array("'"),"\\'",$struct_dzspgb_row);

      $struct_dzspgb_row_empty = str_replace(array("\r","\r\n","\n"),'',$dzspgb_forportal->generate_admin_row_part1(array('empty' => false )).$dzspgb_forportal->generate_admin_row_part2(array()));
      $struct_dzspgb_row_part = str_replace(array("\r","\r\n","\n"),'',$dzspgb_forportal->generate_admin_row_part_part1(array()).$dzspgb_forportal->generate_admin_row_part_part2(array()));
      $struct_dzspgb_row_part = str_replace(array("'"),"\\'",$struct_dzspgb_row_part);
      $struct_dzspgb_row_part_nonactive = str_replace(array("\r","\r\n","\n"),'',$dzspgb_forportal->generate_admin_row_part_part1(array('part'=>'nonactive')).$dzspgb_forportal->generate_admin_row_part_part2(array('part'=>'nonactive')));
      $struct_dzspgb_row_part_nonactive = str_replace(array("'"),"\\'",$struct_dzspgb_row_part_nonactive);



      ?>
        <script>
          var dzspgb_settings={
            is_admin: 'on'
            , struct_row: '<?php echo $struct_dzspgb_row; ?>' // -- this is from appending PLUS
            , struct_row_empty: '<?php echo $struct_dzspgb_row_empty; ?>' // -- this is for appending from the form
            , struct_row_part: '<?php echo $struct_dzspgb_row_part; ?>'
            , struct_row_part_nonactive: '<?php echo $struct_dzspgb_row_part_nonactive; ?>'
          }</script><?php








      wp_enqueue_script('dzspgb', $this->base_url . 'pagebuilder/pagebuilder.js',array('jquery'));
      wp_enqueue_style('dzspgb', $this->base_url . 'pagebuilder/pagebuilder.css');

      wp_enqueue_script('dzsdtf_tooltip', $this->base_url . 'libs/dzstooltip/dzstooltip.js',array('jquery'));
      wp_enqueue_style('dzsdtf_tooltip', $this->base_url . 'libs/dzstooltip/dzstooltip.css');

      wp_enqueue_script('jquery-ui-core');
      wp_enqueue_script('jquery-ui-slider', array('jquery', 'jquery-ui-core'));
      wp_enqueue_style('jquery-ui-base', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8/themes/base/jquery-ui.css');
      wp_enqueue_script('dzspgb_print_templates', admin_url('?action=dzspgb_print_templates'));



    }
    if($post && $post->post_type=='zfolio_grid'){



      wp_enqueue_script('gridbuilder', $this->base_url . 'libs/gridbuilder/gridbuilder.js');
      wp_enqueue_style('gridbuilder', $this->base_url . 'libs/gridbuilder/gridbuilder.css');
      wp_enqueue_script('dzsselector', $this->base_url . 'libs/dzsselector/dzsselector.js');
      wp_enqueue_style('dzsselector', $this->base_url . 'libs/dzsselector/dzsselector.css');




    }


    if($post){

      wp_enqueue_script('isotope', $this->base_url . 'libs/isotope/isotope.js');
    }




  }

  function handle_admin_menu(){



    $admin_cap = $this->capability_admin;





    $cap = 'directory_manage_options';

    if(current_user_can('manage_options')){
      $cap = 'manage_options';
    }



    $dzsdtf_page = add_menu_page(''.esc_html__('Directory','dzsdtf'),''.esc_html__('Directory form','dzsdtf'),$cap,$this->adminpagename_mainoptions,array($this,'admin_page_mainoptions'),'div');


  }



  function handle_admin_footer(){


    global $post,$pagenow;










  }







  function handle_plugins_loaded(){

    // -- submit mail

    if (isset($_GET['action']) && $_GET['action'] == $this->name_frontend_forms) {



      parse_str($_POST['postdata'], $output_arr);



      $po= get_post($output_arr['layout']);




      $field_label = '';
      $field_name = '';
      $field_val = '';



      $msg_template = '<strong>{{name_label}}</strong>: {{name_value}}<br>
{{extra_fields}}<br><br>
{{message_value}}';



      foreach ($output_arr as $lab => $it){



        $val = $it;
        $field_label = $lab;
        $field_name = $lab;
        $field_val = $val;



        if($lab === 'layout'||$lab === 'email_target'){

          continue;
        }



        preg_match_all("/\[dzspgb_element[^dzs]*?input_name=\"".$lab."\".*?\]/", $po->post_content, $output_array2);



        if($output_array2){
          if(is_array($output_array2[0]) && count($output_array2[0])){
            $temp = $output_array2[0][0];


            preg_match_all("/input_label_name=\"(.*?)\"/", $temp, $output_array);


            if(isset($output_array[1]) && isset($output_array[1][0])){
              $field_label = $output_array[1][0];
            }


          }
        }


        $field_label = str_replace('...','',$field_label);

        $countl = 0;
        $countv = 0;

        $msg_template = str_replace('{{'.$field_name.'_label}}', $field_label, $msg_template,$countl);
        $msg_template = str_replace('{{'.$field_name.'_value}}', $field_val, $msg_template,$countv);




        if($countl==0 && $countv==0 && $field_name!='subject'){
          echo 'hmm'.$field_name;
          $msg_template = str_replace('{{extra_fields}}', '<strong>'.$field_label.'</strong>: '.$field_val.'<br>{{extra_fields}}', $msg_template);
        }




        echo $field_label.'  /  '.$field_name.' : '.$val. ' |||| ';
      }

      echo '
            
            '.$msg_template;

      $msg_template = str_replace('{{extra_fields}}', '', $msg_template);



      $this->mail(array(

        'sender'=>$output_arr['email'],
        'target'=>'{{admin}}',
        'message'=>$msg_template,
        'subject'=>$output_arr['subject'],
      ));

//            print_r("CEVA");




      die();


    }








  }


  function check_posts() {

    // --- check posts
    if (isset($_GET['dzsdtf_shortcode_generator_button']) && $_GET['dzsdtf_shortcode_generator_button'] == 'on') {


      include_once($this->base_path . 'admin/shortcode_generator_button/generator.php');
      define('DONOTCACHEPAGE', true);
      define('DONOTMINIFY', true);

    }
    if (isset($_GET['dzsdtf_shortcode_generator_divider']) && $_GET['dzsdtf_shortcode_generator_divider'] == 'on') {


      include_once($this->base_path . 'admin/shortcode_generator_divider/generator.php');
      define('DONOTCACHEPAGE', true);
      define('DONOTMINIFY', true);


      wp_enqueue_style('wp-color-picker');
      wp_enqueue_script('wp-color-picker');

    }



  }

  function admin_page_mainoptions() {

    include_once ("class_parts/admin_page_mainoptions.php");

  }









  function post_get_attachment_url(){


    $bg_url = wp_get_attachment_image_src($_POST['postdata'], 'full');





    echo $bg_url[0];


    die();
  }




  function vc_enqueue_editor_scripts_befe(){

    // -- enqueue script in visual composer front end editor


    wp_enqueue_style( 'video.player', $this->base_url . 'libs/videogallery/vplayer.css');
    wp_enqueue_script( 'video.player', $this->base_url . 'libs/videogallery/vplayer.js');





    if(defined('dzsdtf_THEME_URL')){

      wp_enqueue_script('audio.player', dzsdtf_THEME_URL . 'libs/audioplayer/audioplayer.js');
      wp_enqueue_style('audio.player', dzsdtf_THEME_URL . 'libs/audioplayer/audioplayer.css');
    }
  }















  function generate_heading_wrap_start($heading_style, $pargs=array()){




    $margs = array(
      'extra_classes' => 'the-variable-heading ',
    );


    if(is_array($pargs)){
      $margs = array_merge($margs,$pargs);
    }


    $h_wrap_start = '<'.$heading_style.' class="'.$margs['extra_classes'].'">';

    if($heading_style=='h-group-1'||$heading_style=='h-group-2'){

      $h_wrap_start = '<h3 class="the-variable-heading '.$heading_style.'">';
    }

    return $h_wrap_start;
  }
  function generate_heading_wrap_end($heading_style, $pargs=array()){



    $margs = array(

    );


    if(is_array($pargs)){
      $margs = array_merge($margs,$pargs);
    }




    $h_wrap_end = '</'.$heading_style.'>';

    if($heading_style=='h-group-1'||$heading_style=='h-group-2'){

      $h_wrap_end = '</h3>';
    }
    return $h_wrap_end;
  }



  function sanitize_post_type_slug_to_id($arg, $post_type){

    if($arg && strpos($arg, 'dzs')!==0 && is_numeric($arg)==false){


      $args = array(
        'post_type'      => $post_type,
        'posts_per_page' => 1,
        'post_name__in'  => array($arg),
        'fields'         => 'ids'
      );
      $qr = get_posts( $args );


      if(isset($qr[0])){
        return $qr[0];
      }







    }



    return $arg;
  }





  function parse_button_style($button_style){




    $button_style = str_replace('``','"',$button_style);

    $button_style_arr = array();

    try{
      $button_style_arr = json_decode($button_style,true);
    }catch(Exception $e){

    }


    if(isset($button_style_arr['style'])==false){
      $button_style_arr['style'] = '';
    }
    if(isset($button_style_arr['padding'])==false){
      $button_style_arr['padding'] = '';
    }
    if(isset($button_style_arr['rounded'])==false){
      $button_style_arr['rounded'] = '';
    }

    $button_style_arr['style'] = str_replace('color-highlight','style-highlight', $button_style_arr['style']);

    return $button_style_arr;




  }




















  function sanitize_id_to_src($arg){


    if(is_numeric($arg)){

      $imgsrc = wp_get_attachment_image_src($arg, 'full');


      return $imgsrc[0];
    }else{
      return $arg;
    }


  }











  function convert_media_to_url($arg){

    if (is_numeric($arg)) {
      $bg_url = wp_get_attachment_image_src($arg, 'full');

      $bg_url = $bg_url[0];

    } else {
      $bg_url = $arg;
    }

    return $bg_url;
  }



































  function shortcode_dzsdtf_separator($atts=array(), $content = ''){
    $fout = '';

    $taxonomy = 'timeline_items_cat';

    $margs = array(

      'style'=>'transparent',
      'height'=>'',
      'is_style_black'=>'',
      'custom_color'=>'',
    );


    if (!isset($atts) || $atts == false) {
      $atts = array();
    }

    $margs = array_merge($margs, $atts);






    if($margs['style']=='transparent'){
      $fout.='<span style="display: block; height:'.$margs['height'].'px; "></span>';
    }else{

      $fout.='<span style="display: block; ';

      if($margs['height']){
        $fout.=' margin-bottom:'.$margs['height'].'px; ';
      }


      if($margs['custom_color']){

        $fout.='background-color: '.$margs['custom_color'];
      }


      $fout.=' "';

      $fout.=' class="'.$margs['style'].' divider dzsdtf-divider-from-element ';

      if($margs['is_style_black']=='on'){

        $fout.=' style-black';
      }

      $fout.='" ';


      $fout.='></span>';
    }







    $this->shortcode_index++;
    return $fout;


  }










  function post_save_mo() {

    $auxarray = array();
    // -- parsing post data
    parse_str($_POST['postdata'],$auxarray);








    parse_str($_POST['ultibox_item'],$ultibox_item_arr);

    update_option('dzsdtf_ultibox_item',$ultibox_item_arr);



    parse_str($_POST['page_item'],$page_item_arr);

    update_option('dzsdtf_page_item',$page_item_arr);

//	    print_rr($ultibox_item_arr);


    $auxarray = array_merge($this->db_mainoptions, $auxarray);

    update_option($this->dbname_mainoptions,$auxarray);
    die();
  }





  function get_the_post_thumbnail_url( $post = null, $size = 'post-thumbnail' ) {
    $post_thumbnail_id = get_post_thumbnail_id( $post );
    if ( ! $post_thumbnail_id ) {
      return false;
    }
    return wp_get_attachment_image_url( $post_thumbnail_id, $size );
  }

  function post_get_post_thumb_url() {

    $auxarray = array();
    // -- parsing post data


    echo get_the_post_thumbnail_url($_POST['postdata'], array(100,100));
    die();
  }










  function post_dzs_update_term_order() {

    $auxarray = array();
    // -- parsing post data
    $arr = json_decode(stripslashes($_POST['postdata']),true);


    print_r($_POST);
    print_r($arr);

    foreach ($arr as $po){

      update_post_meta($po['id'],$_POST['meta_key'], $po['order']);
    }
    die();
  }


}



if(function_exists('vc_dzsdtf_icon_selector')==false) {
  function vc_dzsdtf_icon_selector($settings, $value) {

    $dependency = '';


    $fout = '<div class="vc_dzsdtf_layout_chooser-con" ' . $dependency . '>
                <input type="text" class="vc_dzsdtf_multiple_checkbox-input    " name="' . $settings['param_name'] . '" value="' . $value . '"  style="display:none"/>
';

    $multi_values = array();

    $multi_values = explode(',',$value);











    $fout.='  <select class="dzs-style-me  opener-listbuttons wpb_vc_param_value wpb-select ' . $settings['type'] . '_field  "  name="' . $settings['param_name'] . '"" >
                             ';


    if($value=='dzs-layout--2-cols'){
      $fout.=' selected';
    }



    $values = $settings['value'];

    foreach ($values as $opt){
      $fout.='<option value="'.$opt['value'].'" ';


      if($value==$opt['value']){
        $fout.=' selected';
      }

      $fout.='></option>';
    }







    $fout.='
                        </select>
                        <ul class="dzs-style-me-feeder">'
    ;

    foreach ($values as $opt){

      $fout.='<div class="bigoption">
<span class="option-con"><img src="'.$opt['icon'].'"><span class="option-label"></span></span>
</div>';

    }


    $fout.='
                        </ul>';


    $fout.='</div>';
    return $fout;

  }
}





if(function_exists('dzsdtf_sanitize_to_html')==false){

  function dzsdtf_sanitize_to_html($arg){
    $arg = str_replace('{replacequotquot}','"', $arg);

    return $arg;
  }
}
if(function_exists('dzsdtf_sanitize_term_slug_to_id')==false){
  function dzsdtf_sanitize_term_slug_to_id($arg,$taxonomy_name=''){


    if($taxonomy_name==''){
      global $dzsdtf;

      $taxonomy_name= $dzsdtf->name_port_item_cat;
    }

    if(is_numeric($arg)){

    }else{

      $term = get_term_by('slug', $arg, $taxonomy_name);

      if($term){
        $arg = $term->term_id;
      }

    }


    return $arg;
  }
}
//include_once('dzsdtf_widgets.php');




include_once("class_parts/element-shortcodes.php");